#===================================================================
#       	    --------------------------
#           	             CHBoard
#		    --------------------------
#
#     : âȣ.
#       : contact@koinweb.co.kr
#   Ȩ: http://www.koinweb.co.kr
#       : Admin.pm
#
# Copyright (C) 2001 Koinweb - All rights reserved.
#  α׷  Ǿ   ϰų  
# Ǹ  ϴ.
#
#===================================================================

package Admin;
#======================================================================

use strict;
use Carp;
use Setup qw($CONFIG);
use CH::Getform;
use CH::DBUtil;

#----------------------------------------------------------------------
#
use vars qw(@ISA $VERSION %style $SIDE_MENU $table_top $table_bottom);
@ISA = qw(Board);

$VERSION = sprintf("%d.%02d", q$Revision: 0.71 $ =~ /(\d+)\.(\d+)/);

#----------------------------------------------------------------------
#  忡 Ǵ  Ʈ  .
#----------------------------------------------------------------------

%style = (
	bgcolor		=> 'bgcolor="#eeeeee"',
	bgcolor_title	=> "bgcolor=\"$CONFIG->{table_header_color}\"",
	font_title	=> 'font size="2" color="white" face=""',
	font		=> 'font size="2" color="black" face=""',
	font_red	=> 'font size="2" color="red" face=""',
	hr		=> 'hr size="1"',
	arrow		=> "<img src=\"$CONFIG->{images_url}/a_arrow.gif\" align=\"absmiddle\">",
	spacer		=> 'spacer type="block" height="5" width="1"'
	);

#----------------------------------------------------------------------
#  ƿƼ ޴.
#----------------------------------------------------------------------

$SIDE_MENU = <<END_OF_MENU;
	<table border="0" cellpadding="4" cellspacing="0" width="100%">
	<tr $style{bgcolor_title}>
		<td>
			<$style{font_title}><b>  ޴</b></font>
		</td>
	</tr>
	<tr>
		<td $style{bgcolor}><$style{font}>
			$style{arrow}<a href="index.cgi?ch=Admin&do=ForumCfg"></a>
		</td>
	</tr>
	<tr $style{bgcolor_title}>
		<td>
			<$style{font_title}><b>۷ </b></font>
		</td>
	</tr>
	<tr>
		<td $style{bgcolor}><$style{font}>
			$style{arrow}<a href="index.cgi?ch=Admin&do=CreateConference">۷ </a><br>
			$style{arrow}<a href="index.cgi?ch=Admin&do=ModifyConference">۷ </a><br>
			$style{arrow}<a href="index.cgi?ch=Admin&do=SortConference">۷ </a><br>
			$style{arrow}<a href="index.cgi?ch=Admin&do=DeleteConference">۷ </a><br>
		</td>
	</tr>
	<tr $style{bgcolor_title}>
		<td>
			<$style{font_title}><b> </b></font>
		</td>
	</tr>
	<tr>
		<td $style{bgcolor}><$style{font}>
			$style{arrow}<a href="index.cgi?ch=Admin&do=CreateForum"> </a><br>
			$style{arrow}<a href="index.cgi?ch=Admin&do=ModifyForum"> </a><br>
			$style{arrow}<a href="index.cgi?ch=Admin&do=MoveForum"> ̵</a><br>
			$style{arrow}<a href="index.cgi?ch=Admin&do=DeleteForum"> </a><br>
		</td>
	</tr>
	<tr $style{bgcolor_title}>
		<td>
			<$style{font_title}><b>ȸ </b></font>
		</td>
	</tr>
	<tr>
		<td $style{bgcolor}><$style{font}>
			$style{arrow}<a href="index.cgi?ch=Admin&do=ModifyMember">ȸ </a><br>
			$style{arrow}<a href="index.cgi?ch=Admin&do=ActivateMember">ȸ Ȱ</a><br>
			$style{arrow}<a href="index.cgi?ch=Admin&do=DeactivateMember">ȸ Ȱ</a><br>
			$style{arrow}<a href="index.cgi?ch=Admin&do=DeleteMember">ȸ </a><br>
		</td>
	</tr>
	<tr $style{bgcolor_title}>
		<td>
			<$style{font_title}><b> </b></font>
		</td>
	</tr>
	<tr>
		<td $style{bgcolor}><$style{font}>
			$style{arrow}<a href="index.cgi?ch=Admin&do=MailNews"> </a><br>
		</td>
	</tr>
	<tr $style{bgcolor_title}>
		<td>
			<$style{font_title}><b> </b></font>
		</td>
	</tr>
	<tr>
		<td $style{bgcolor}><$style{font}>
			
			$style{arrow}<a href="index.cgi?ch=Admin&do=WriteAnnounce"> </a><br>
			$style{arrow}<a href="index.cgi?ch=Admin&do=ModifyAnnounce"> </a><br>
			$style{arrow}<a href="index.cgi?ch=Admin&do=DeleteAnnounce"> </a></font><br>
		</td>
	</tr>
	<tr $style{bgcolor_title}>
		<td>
			<$style{font_title}><b>ý </b></font>
		</td>
	</tr>
	<tr>
		<td $style{bgcolor}><$style{font}>
			$style{arrow}<a href="index.cgi?ch=Admin&do=system_info"> ý </a><br>
		</td>
	</tr>
	</table>
END_OF_MENU

#----------------------------------------------------------------------
#   ɼ  ؽ ̺.
#----------------------------------------------------------------------

sub new {
	my $this = shift;
	my $class = ref($this) || $this;

	my $self = {};
	
	$self->{onoff} = [ qw(On Off) ];
	$self->{forum_type} = [ qw(0 1 9) ];
	
	bless $self, $class;
	
	return $self;
}

#----------------------------------------------------------------------
#  ƿƼ ó ȭ.
#----------------------------------------------------------------------

sub Home {
	my $self = shift;
	my $welcome_msg = " ƿƼ   ȯմϴ.";

	$self->main_form($welcome_msg);
}

#----------------------------------------------------------------------
#   ƾ.
#----------------------------------------------------------------------

sub ForumCfg {
	my $self = shift;

	#----------------------------------------------------------------------
	#   ɼ ؽ  ̺.
	#----------------------------------------------------------------------

	my $OnOff = 'Ѵ Ѵ';
	my %FORUM_CFG = (
		'BASIC'	=> {
			title			=> [ 0, $CONFIG->{title} ],
			site_title		=> [ 1, $CONFIG->{site_title} ],
			admin_email		=> [ 2, $CONFIG->{admin_email} ],
			copyright		=> [ 3, $CONFIG->{copyright} ],
			site_url		=> [ 4, $CONFIG->{site_url} ],
			contact_email		=> [ 5, $CONFIG->{contact_email} ]
		},
	
		'PATH' 	=> {
			public_directory	=> [ 0, $CONFIG->{public_directory} ],
			public_url		=> [ 1, $CONFIG->{public_url} ],
			script_path		=> [ 2, $CONFIG->{script_path} ],
			script_url		=> [ 3, $CONFIG->{script_url} ],
			sendmail_path		=> [ 4, $CONFIG->{sendmail_path} ],
			smtp			=> [ 5, $CONFIG->{smtp} ]
		},
	
		'STYLE'	=> {
			table_width		=> [ 0, $CONFIG->{table_width} ],
			table_align		=> [ 1, $CONFIG->{table_align} ],
			table_border_color	=> [ 2, $CONFIG->{table_border_color} ],
			table_border_width	=> [ 3, $CONFIG->{table_border_width} ],
			table_cellpadding	=> [ 4, $CONFIG->{table_cellpadding} ],
			table_cellspacing	=> [ 5, $CONFIG->{table_cellspacing} ],
			list_color1		=> [ 6, $CONFIG->{list_color1} ],
			list_color2		=> [ 7, $CONFIG->{list_color2} ],
			table_header_color	=> [ 8, $CONFIG->{table_header_color} ],
			header_font_face	=> [ 9, $CONFIG->{header_font_face} ],
			header_font_size	=> [ 10, $CONFIG->{header_font_size} ],
			header_font_color	=> [ 11, $CONFIG->{header_font_color} ],
			table_header_color2	=> [ 12, $CONFIG->{table_header_color2} ],
			header_font_face2	=> [ 13, $CONFIG->{header_font_face2} ],
			header_font_size2	=> [ 14, $CONFIG->{header_font_size2} ],
			header_font_color2	=> [ 15, $CONFIG->{header_font_color2} ],
			msg_font_face		=> [ 16, $CONFIG->{msg_font_face} ],
			msg_font_size		=> [ 17, $CONFIG->{msg_font_size} ],
			msg_font_color		=> [ 18, $CONFIG->{msg_font_color} ],
			msg_box_color		=> [ 19, $CONFIG->{msg_box_color} ],
			time_font_color		=> [ 20, $CONFIG->{time_font_color} ],
			forum_bgcolor		=> [ 21, $CONFIG->{forum_bgcolor} ],
		},
		
		'MEMBER' => {
			default_level		=> [ 0, $CONFIG->{default_level}, 'select', '1 2 3' ],
			register_via_email	=> [ 1, $CONFIG->{register_via_email}, 'radio', $OnOff ],
			member_status		=> [ 2, $CONFIG->{member_status}, 'radio', $OnOff ],
			auth_allow_registration	=> [ 3, $CONFIG->{auth_allow_registration}, 'radio', $OnOff ],
			auth_notify_admin_on_registration => [ 4, $CONFIG->{auth_notify_admin_on_registration}, 
						'radio', $OnOff ],
			auth_notify_user_on_activation => [ 5, $CONFIG->{auth_notify_user_on_activation}, 
						'radio', $OnOff ],
			},
		
		'OPT' => {
			per_page		=> [ 0, $CONFIG->{per_page} ],
			threads_perpage		=> [ 1, $CONFIG->{threads_perpage} ],
			use_chcode		=> [ 2, $CONFIG->{use_chcode}, 'radio', $OnOff ],
			attach			=> [ 3, $CONFIG->{attach}, 'radio', $OnOff ],
			attach_size		=> [ 4, $CONFIG->{attach_size}, ],
			time_zone		=> [ 5, $CONFIG->{time_zone} ],
			time_zone_offset	=> [ 6, $CONFIG->{time_zone_offset} ],
			hot_icon		=> [ 7, $CONFIG->{hot_icon} ],
			date_format		=> [ 8, $CONFIG->{date_format},	'select', 'DT_FORMAT1 DT_FORMAT2 DT_FORMAT3 DT_FORMAT4' ],
			mail_type		=> [ 9, $CONFIG->{mail_type}, 'select', 'TEXT HTML' ],
			mailto_admin		=> [ 10, $CONFIG->{mailto_admin}, 'radio', $OnOff ],
			mailto_mod		=> [ 11, $CONFIG->{mailto_mod}, 'radio', $OnOff ],
			conferences_only	=> [ 12, $CONFIG->{conferences_only}, 'radio', $OnOff ],
			subject_length		=> [ 13, $CONFIG->{subject_length} ],
			word_length_max		=> [ 14, $CONFIG->{word_length_max} ],
			display_member_total	=> [ 15, $CONFIG->{display_member_total}, 'radio', $OnOff ],
			display_last_topic	=> [ 16, $CONFIG->{display_last_topic}, 'radio', $OnOff ],
			hidden_private		=> [ 17, $CONFIG->{hidden_private}, 'radio', $OnOff ],
		}
	);

	my $DESCRIPTION = DB->get_data("$CONFIG->{data_directory}/a_forum_desc.txt");
	
	my $html_output = qq|
	<form method="post">
	<input type="hidden" name="ch" value="Admin">
	<input type="hidden" name="do" value="SaveCfg">
	<table border="0" cellpadding="2" cellspacing="1" width="100%">
	<tr>
		<td $style{bgcolor_title} colspan="2"><$style{font_title}><b>⺻ </b></font>
		</td>
	</tr>|;
	
	my $idx = 0;
	
	foreach ( sort { $FORUM_CFG{BASIC}{$a}[0] <=> $FORUM_CFG{BASIC}{$b}[0] } keys %{$FORUM_CFG{BASIC}} ) {
		my $bgcolor = DB->color($idx);
		
		$html_output .= qq|
		<tr $bgcolor>
		<td><$style{font}>$DESCRIPTION->{$_}</font>
		</td><td>|;
		if ($_ eq "copyright") {
		$html_output .= qq|<textarea name="$_" wrap="virtual" rows="3" cols="34">$FORUM_CFG{BASIC}{$_}[1]</textarea>|;
		}
		else { 
		$html_output .= qq|<input type="text" size="34" name="$_" value="$FORUM_CFG{BASIC}{$_}[1]">|;
		}
		$html_output .= "</td></tr>";
		$idx++;
	}
	
	$html_output .= qq|
	<tr>
		<td $style{bgcolor_title} colspan="2"><$style{font_title}><b> </b></font>
		</td>
	</tr>|;
	
	foreach ( sort { $FORUM_CFG{PATH}{$a}[0] <=> $FORUM_CFG{PATH}{$b}[0] } keys %{$FORUM_CFG{PATH}} ) {
		my $bgcolor = DB->color($idx);
		
		$html_output .= qq|
		<tr $bgcolor>
			<td><$style{font}>$DESCRIPTION->{$_}</font>
			</td><td>
			<input type="text" size="34" name="$_" value="$FORUM_CFG{PATH}{$_}[1]">
		</td></tr>|;
		$idx++;
	}
	
	$html_output .= qq|
	<tr>
		<td $style{bgcolor_title} colspan="2"><$style{font_title}><b>̺, , Ʈ </b></font>
		</td>
	</tr>|;
	my ($bgcolor, $t_align);
	foreach ( sort { $FORUM_CFG{STYLE}{$a}[0] <=> $FORUM_CFG{STYLE}{$b}[0] } keys %{$FORUM_CFG{STYLE}} ) {
		$bgcolor = DB->color($idx);
		$html_output .= qq|
		<tr $bgcolor>
			<td><$style{font}>$DESCRIPTION->{$_}</font>
			</td><td>|;
			if ($_ eq "table_align") {
				$html_output .= "<select name=$_>\n";
				for $t_align ("LEFT", "CENTER", "RIGHT") {
					$html_output .= "<option value=\"$t_align\"";
					$html_output .= " selected" if ($t_align eq $FORUM_CFG{STYLE}{$_}[1]);
					$html_output .= ">$t_align\n";
				}
				$html_output .= "</select>";
			}
			else {
			$html_output .= qq|
			<input type="text" size="10" name="$_" value="$FORUM_CFG{STYLE}{$_}[1]"></td></tr>|;
			}
		$idx++;
	}
	
	$html_output .= qq|
	<tr>
		<td $style{bgcolor_title} colspan="2"><$style{font_title}><b>ȸ  ɼ</b></font>
		</td>
	</tr>|;
	foreach ( sort { $FORUM_CFG{MEMBER}{$a}[0] <=> $FORUM_CFG{MEMBER}{$b}[0] } keys %{$FORUM_CFG{MEMBER}} ) {
		$bgcolor = DB->color($idx);
		if ($FORUM_CFG{MEMBER}{$_}[2] eq "radio") {
			$html_output .= qq|
			<tr $bgcolor>
			<td><$style{font}>$DESCRIPTION->{$_}</font>
			</td><td>|;
			
			my @tmp = split(/ /, $FORUM_CFG{MEMBER}{$_}[3]);
			
			for my $i (@tmp) {
				my $value = ($i eq 'Ѵ') ? 1 : 0;
				$html_output .= "<input type=\"radio\" name=\"$_\" value=\"$value\"";
				$html_output .= " checked" if ($value == $FORUM_CFG{MEMBER}{$_}[1]);
				$html_output .= "><$style{font}>$i.</font> "
			}
			$html_output .= "</td></tr>";
		}
		elsif ($FORUM_CFG{MEMBER}{$_}[2] eq "select") {
			$html_output .= qq|
			<tr $bgcolor>
			<td><$style{font}>$DESCRIPTION->{$_}</font>
			</td><td>|;

			my @tmp = split(/ /, $FORUM_CFG{MEMBER}{$_}[3]);
			
			$html_output .= "<select name=\"$_\">\n";
			for my $i (@tmp) {
				my $value = $i;
				$value = $self->member_level($i);
				$html_output .= "<option value=\"$i\"";
				$html_output .= " selected" if ($i eq $FORUM_CFG{MEMBER}{$_}[1]);
				$html_output .= ">$value\n";
			}
			$html_output .= "</select>\n</td></tr>";
		}
		$idx++;
	}
	
	$html_output .= qq|
	<tr>
		<td $style{bgcolor_title} colspan="2"><$style{font_title}><b>  ɼ</b></font>
		</td>
	</tr>|;
	foreach ( sort { $FORUM_CFG{OPT}{$a}[0] <=> $FORUM_CFG{OPT}{$b}[0] } keys %{$FORUM_CFG{OPT}} ) {
		$bgcolor = DB->color($idx);
		
		if ($FORUM_CFG{OPT}{$_}[2] eq "radio") {
			$html_output .= qq|
			<tr $bgcolor>
			<td><$style{font}>$DESCRIPTION->{$_}</font>
			</td><td>|;
			
			my @tmp = split(/ /, $FORUM_CFG{OPT}{$_}[3]);
			
			for my $i (@tmp) {
				my $value = ($i eq 'Ѵ') ? 1 : 0;
				$html_output .= "<input type=\"radio\" name=\"$_\" value=\"$value\"";
				$html_output .= " checked" if ($value == $FORUM_CFG{OPT}{$_}[1]);
				$html_output .= "><$style{font}>$i.</font> "
			}
			$html_output .= "</td></tr>";
		}
		elsif ($FORUM_CFG{OPT}{$_}[2] eq "select") {
			$html_output .= qq|
			<tr $bgcolor>
			<td><$style{font}>$DESCRIPTION->{$_}</font>
			</td><td>|;

			my @tmp = split(/ /, $FORUM_CFG{OPT}{$_}[3]);
			
			$html_output .= "<select name=\"$_\">\n";
			for my $i (@tmp) {
				my $value = $i;
				if ($_ eq "date_format") {
					my $format = sub {
						my $s = shift;
						my %format_hash = (
							DT_FORMAT1 => '2001 12 31,  00:00',
							DT_FORMAT2 => '2001-12-31,  00:00',
							DT_FORMAT3 => '01 12 31,  00:00',
							DT_FORMAT4 => '01-12-31,  00:00',
						);
						return $format_hash{$s};
						};
					$value = &$format($i);
				}
				elsif ($_ eq "default_level") {
					$value = $self->member_level($i);
				}
				$html_output .= "<option value=\"$i\"";
				$html_output .= " selected" if ($i eq $FORUM_CFG{OPT}{$_}[1]);
				$html_output .= ">$value\n";
			}

			$html_output .= "</select>\n</td></tr>";
		}
		else {
			$html_output .= qq|
			<tr $bgcolor>
			<td><$style{font}>$DESCRIPTION->{$_}</font>
			</td><td>
			<input type="text" size="10" name="$_" value="$FORUM_CFG{OPT}{$_}[1]">
			</td></tr>|;
		}
		$idx++;
	}
	
	$html_output .= qq|
		<tr $style{bgcolor_title}><td colspan="2">&nbsp;</td></tr>
		</table><br>
		<input type="submit" value="  "> <input type="reset" value="ʱ "></td>
		</form>|;

	$self->main_form($html_output);
}

sub SaveCfg {
	my $self = shift;
	my %add_arg = (
		data_directory		=> $IN->{script_path} . "/data",
		cat_file		=> $IN->{script_path} . "/data/category.list",
		member_directory	=> $IN->{script_path} . "/data/Members",
		images_url		=> $IN->{public_url} . "/images",
		upload			=> $IN->{public_directory} . "/files",
		db_delim		=> '|',
		session_path		=> $IN->{script_path} . "/data/Members/session",
		pm_path			=> $IN->{script_path} . "/data/Members/pm",
		template_path		=> $IN->{script_path} . "/templates/forum",
		forum_path		=> $IN->{script_path} . "/data/forum",
		users			=> $IN->{script_path} . "/data/Members/member_list.db",
	);
	
	my $config_file = "$CONFIG->{data_directory}/chboard.cfg";
	my $cfg = DB->get_data($config_file);
	
	foreach (keys %$IN) {
		exists $cfg->{$_} and $cfg->{$_} = $IN->{$_};
	}
	
	foreach (keys %add_arg) { 
		$cfg->{$_} = $add_arg{$_};
	}
	
	$self->_write($config_file, $cfg);
	
	my $result = "<BR><$style{font}><B>   ŵǾϴ!</B></font>";
	
	$self->main_form($result);
}

sub CreateConference {
	my $self = shift;
	my $html_output = qq|<form method="post">
	<input type="hidden" name="ch" value="Admin">
	<input type="hidden" name="do" value="SaveConference">
	<table border="0" cellpadding="2" cellspacing="1" width="100%">
	<tr>
		<td colspan="4"><$style{font}><b>   ۷ ϴ.</b><br>
			<OL>
				<li>۷ ̸  Էմϴ.
				۷ ̸ //ѱ ̿Ͻ  ,  HTML ±׸
				Ͻ  ֽϴ.</li>
			
				<li>۷ ¸ üũϽ , "۷ " ư ŬϽʽÿ.
				, ĭ۷ ° Ȱ   ȭ鿡 Ÿ ʽϴ.</li>
			</OL></font>
			<$style{font_red}>۷  ݵ Էؾ մϴ.<font>
		</td>
	</tr>
	<tr>
		<th $style{bgcolor_title} colspan="2"><$style{font_title}><b>۷ </b></font>
		</th>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%"><$style{font}><b>۷ ̸:</b></font>
		</td>
		<td width="70%"><input type="text" name="Name" size="40"></td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%" valign="top"><$style{font}><b>۷ :</b></font>
		</td>
		<td width="70%"><textarea wrap name="Desc" rows="3" cols="40" value=""></textarea></td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%" valign="top"><$style{font}><b>۷ :</b></font>
		</td>
		<td width="70%"><$style{font}>
		<input type="radio" name="Status" value="On" checked> Ȱ 
		<input type="radio" name="Status" value="Off"> Ȱ</font>
		</td>
	</tr>

	<tr bgcolor="white">
		<td width="30%" valign="top">&nbsp;</td>
		<td width="70%"><br>
		<input type="submit" value="۷ ">
		<input type="reset" value="ʱ "></td>
	</tr>
	</table>
	</form>|;

	$self->main_form($html_output);
}

sub SaveConference {
	my $self = shift;
	my $category = $self->_read_cat();
	
	open (FH, "$CONFIG->{data_directory}/cat_id.txt");
		flock(FH, 1);
		my $cat_id = <FH> + 1;
	close FH;
	open (FH, ">$CONFIG->{data_directory}/cat_id.txt");
		flock(FH, 2);
		print FH $cat_id;
	close FH;

	chomp $IN->{Desc};
	
	my $cat_hash = {
		ID	=> scalar @{ [ keys %$category ] } + 1,
		Status	=> $IN->{Status},
		Name	=> $IN->{Name},
		Desc	=> $IN->{Desc},
		ForumList => [] };

	$category->{ "CatID" . $cat_id } = $cat_hash;
	
	$self->_write($CONFIG->{cat_file}, $category);
	
	my $result = "<BR><B>$IN->{c_name} ۷  ϴ!</B>";
	my $OnOff = $IN->{status} eq "On" ? 'Ȱ' : 'Ȱ';
	
	$result .= qq|<BR><BR>
	<table border="0" cellpadding="2" cellspacing="1" width="100%">
	<tr>
		<td $style{bgcolor_title} colspan="2"><$style{font_title}><b>۷  </b></font>
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%"><$style{font}>۷ ̸:</font>
		</td>
		<td width="70%"><$style{font}>$IN->{Name}</font>
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%"><$style{font}>۷ :</font>
		</td>
		<td width="70%"><$style{font}>$IN->{Desc}</font>
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%"><$style{font}>۷ :</font>
		</td>
		<td width="70%"><$style{font}>$OnOff</font>
		</td>
	</tr>
	</table>|;
	
	$self->main_form($result);
}

sub ConferenceTableHeader {
	my $html_output = "<tr>";
	
	$html_output .= "<th $style{bgcolor_title} nowrap><$style{font_title}></font>
		</th>" if $_[1] eq "checkbox";
	
	$html_output .= qq|	
		<th $style{bgcolor_title} nowrap><$style{font_title}></font>
		</th>
		<th $style{bgcolor_title}><$style{font_title}≯</font>
		</th>
		<th $style{bgcolor_title}><$style{font_title}></font>
		</th>
	</tr>|;
}

sub ModifyConference {
	my $self = shift;
	my $cat = $self->_read_cat();
	my $idx = 0;
	
	my $html_output = qq|
	<form method="post">
	<input type="hidden" name="ch" value="Admin">
	<input type="hidden" name="do" value="SaveModifyConferences">
	<table border="0" cellpadding="2" cellspacing="1" width="100%">
	<tr>
		<td colspan="4"><$style{font}><b>   ۷ մϴ.</b><br>
			<OL>
				<li>  ۷ ùڽ üũϰ, /̸/ Ĩϴ.
				   ۷   ֽϴ.</li>
			
				<li>  ģ 뿡 ̻   Ȯ ,
				"۷ " ư ʽÿ.</li>
			</OL></font>
		</td>
	</tr>|;

	$html_output .= $self->ConferenceTableHeader("checkbox");
	
	foreach (sort keys %$cat) {
		my $bgcolor = DB->color($idx);
		
		$html_output .= qq|
		<tr $bgcolor>
		<td align="center"><input type="checkbox" name="$_" value="modify">
		</td>
		<td><select name="$_-Status">|;
		
		for my $onoff (@{$self->{onoff}}) {
			$html_output .= "<option value=\"$onoff\"";
			$html_output .= " selected" if $cat->{$_}->{Status} eq $onoff;
			$html_output .= ">" . $self->OnOff($onoff);
		}

		$html_output .= qq|
		<td><input type="text" size="34" name="$_-Name" value="$cat->{$_}->{Name}"></td>
		</td>
		<td><textarea wrap="virtual" rows="2" cols="34" name="$_-Desc">$cat->{$_}->{Desc}</textarea></td>
		</tr>|;
		
		$idx++;
	}
	$html_output .= qq|
	<tr bgcolor="white">
		<td align="center" colspan="4"><BR>
		<input type="submit" value="۷ "></td>
	</tr></table>
	</form>|;
	
	$self->main_form($html_output);
}

sub SaveModifyConferences {
	my $self = shift;
	my ($html_output, %cat_list, %modify_cat);
	my $cat_to_modify = 0;
	
	foreach (keys %$IN) { 
		if ($IN->{$_} eq "modify") {
			$cat_list{$_} = 1;
			$cat_to_modify = 1;
		}
		$_ =~ /^(.*)-(.+)$/ and ${$modify_cat{$1}}{$2} = $IN->{$_};
	}
	
	unless ($cat_to_modify) { 
		$html_output .= "<BR><$style{font}><B>Ͻ ۷ ϴ.!</B></font>";
	}
	else {
		my $cat = $self->_read_cat();
	
		$html_output .= qq|
		<table border="0" width="100%" cellpaddin="2" cellspacing="1">
		<tr bgcolor="white">
			<td colspan="3"><$style{font}><b>Ͻ ۷  ϴ.</b></font><P>
			</td>
		</tr>|;
		
		$html_output .= $self->ConferenceTableHeader();
		
		my $idx = 0;
		foreach my $key (keys %$cat) {
			if ($cat_list{$key}) {
				my $bgcolor = DB->color($idx);
				my $onoff = $self->OnOff(${$modify_cat{$key}}{Status});
				$html_output .= qq|
				<tr $bgcolor>
					<td align="center"><$style{font}>$onoff</font>
					</td><td><$style{font}>${$modify_cat{$key}}{Name}</font>
					</td><td><$style{font}>${$modify_cat{$key}}{Desc}</font>
					</td>
				</tr>|;
				
				foreach (keys %{$modify_cat{$key}}) {
					$cat->{$key}->{$_} = ${$modify_cat{$key}}{$_};
				}
				$idx++;
			}
		}
		
		$html_output .= "</table>";
		
		$self->_write($CONFIG->{cat_file}, $cat);
	}
	
	$self->main_form($html_output);
}

sub DeleteConference {
	my $self = shift;
	my $cat = $self->_read_cat();
	my $idx = 0;
	
	my $html_output = qq|
	<form method="post">
	<input type="hidden" name="ch" value="Admin">
	<input type="hidden" name="do" value="DoDeleteConferences">
	<table border="0" cellpadding="2" cellspacing="1" width="100%">
	<tr>
		<td colspan="4"><$style{font}><b>   ۷ մϴ.</b><br>
			<OL>
				<li> ۷ ùڽ üũմϴ.
				   ۷   ֽϴ.</li>
			
				<li>"۷ " ư ʽÿ.</li>
			</OL></font>
			<$style{font_red}>   ۷    , ۷ ȿ
			 ԵǾ     ִ  ͵ ˴ϴ.</font>
		</td>
	</tr>|;
	
	$html_output .= $self->ConferenceTableHeader("checkbox");
	
	foreach (sort keys %{$cat}) {
		my $bgcolor = DB->color($idx);
		my $onoff = $self->OnOff($cat->{$_}->{Status});
		$html_output .= qq|
		<tr $bgcolor>
			<td align="center"><input type="checkbox" name="$_" value="delete">
			</td><td><$style{font}>$onoff</font>
			</td><td><$style{font}>$cat->{$_}->{Name}</font>
			</td><td><$style{font}>$cat->{$_}->{Desc}</font>
			</td>
		</tr>|;
		
		$idx++;
	}
	$html_output .= qq|
	<tr bgcolor="white">
		<td align="center" colspan="4"><BR>
		<input type="submit" value="۷ "></td>
	</tr></table>
	</form>|;
	
	$self->main_form($html_output);
}

sub DoDeleteConferences {
	my $self = shift;
	my ($html_output, @delete_list);
	my $cat_to_delete = 0;
	
	foreach (keys %$IN) { 
		if ($IN->{$_} eq "delete") {
			push @delete_list, $_;
			$cat_to_delete = 1;
		}
	}
	
	unless ($cat_to_delete) { 
		$html_output = "<BR><$style{font}><B> ۷ ϴ.!</B></font>";
	}
	else {
		my $cat = $self->_read_cat();
		
		$html_output = "<BR><$style{font}><b> ۷  Ͽϴ!</b></font><P>";
		$html_output .= "<P><div align=\"left\"><$style{font}><ol>";
		
		for (@delete_list) { 
			$html_output .= "<li>$cat->{$_}->{Name}</li>";
			delete $cat->{$_}; 
		}
		
		$html_output .= "</ol></font></div>";
		
		$self->_write($CONFIG->{cat_file}, $cat);
	}

	$self->main_form($html_output);
}

sub SortConference {
	my $self = shift;
	
	my $html_output = qq|
	<form method="post">
	<input type="hidden" name="ch" value="Admin">
	<input type="hidden" name="do" value="SaveSortedConference">
	<table border="0" cellpadding="2" cellspacing="1" width="100%">
	<tr>
		<td colspan="4"><$style{font}><b>   ۷ մϴ.</b><br>
			<OL>
				<li> ڽ  ID ȣ մϴ.
				ȣ     ϴ.</li>
			
				<li>"۷ " ư ʽÿ.</li>
			</OL></font>
			<$style{font_red}> ID ȣ ġ ʵ Ͻʽÿ. ,  ID ȣ
			Ȱ ۷    ߻   Ѵ ̷ ʽϴ.</font>
		</td>
	</tr>|;
	
	my $cat = $self->_read_cat();
	$html_output .= $self->ConferenceTableHeader("checkbox");
	
	my ($onoff, $bgcolor);
	my $bgidx = 0;
	
	foreach ( sort{ $cat->{$a}->{ID} <=> $cat->{$b}->{ID} } keys %$cat) {
		$bgcolor = DB->color($bgidx);
		$onoff = $self->OnOff($cat->{$_}->{Status});
		
		$html_output .= "<tr $bgcolor><td><select name=\"$_\">\n";
			
			for (my $i=1; scalar @{ [ keys %$cat ] } + 1 > $i; $i++) {
				$html_output .= "<option value=$i";
				$html_output .= " selected" if $cat->{$_}->{ID} eq $i;
				$html_output .= ">$i\n";
			}
			$html_output .= qq|</select>
			</td><td><$style{font}>$onoff</font>
			</td><td><$style{font}>$cat->{$_}->{Name}</font>
			</td><td><$style{font}>$cat->{$_}->{Desc}</font>
			</td>
		</tr>|;
		$bgidx++;
	}
	
	$html_output .= qq|
	<tr><td colspan="4" align="center"><BR><input type="submit" value="۷ "></td>
	</tr></table></form>|;

	$self->main_form($html_output);
}

sub SaveSortedConference {
	my $self = shift;
	my ($sort_to_cat, $html_output);
	my $cat = $self->_read_cat();
	
	foreach (%$IN) {
		if (exists($cat->{$_})) {
			$cat->{$_}->{ID} = $IN->{$_};
			$sort_to_cat = 1;
		}
	}
	
	$self->_write($CONFIG->{cat_file}, $cat);
	
	if ($sort_to_cat) {
		$html_output = "<BR><B>۷   ŵǾϴ!</B>";
	}
	else {
		$html_output = "<BR><B> ۷ ϴ.</B>";
	}
	
	$self->main_form($html_output);
}

sub CreateForum {
	my $self = shift;
	my $cat = $self->_read_cat();
	my $users = DB->get_data("$CONFIG->{member_directory}/member_list.db");
	my ($uid, $output_mod);
	
	foreach (keys %{$users}) {
		$uid = $self->member_data($_);
		if ($uid->{MEMBER_LEVEL} > 2) {
			$output_mod .= qq~<input type="checkbox" name="$_" value="moderator">$uid->{MEMBER_ID}~;
			$output_mod .= "(". $self->member_level($uid->{MEMBER_LEVEL}) . ")";
		}
	}
	
	my $html_output = qq|<form method="post">
	<input type="hidden" name="ch" value="Admin">
	<input type="hidden" name="do" value="SaveForum">
	<table border="0" cellpadding="2" cellspacing="1" width="100%">
	<tr>
		<td colspan="4"><$style{font}><b>    ϴ.</b><br>
			<OL>
				<li>   ۷ մϴ.</li>
				<li> ̸  Էմϴ.
				 ̸ //ѱ ̿Ͻ  ,  HTML ±׸
				Ͻ  ֽϴ.</li>
			
				<li> ¸ üũϽ , " " ư ŬϽʽÿ.
				,  ° Ȱ    ȭ鿡 Ÿ ʽϴ.</li>
				<li>  ȸ     Ǵ ڰ Ȯ 
				 ؾ߸ ش   ϵ˴ϴ.</li>
				<li> ڸ մϴ.  ڸ   ֽϴ.
			</OL></font>
			<$style{font_red}> ̸ ݵ Էؾ մϴ.<font>
		</td>
	</tr>
	<tr>
		<th $style{bgcolor_title} colspan="2"><$style{font_title}><b> </b></font>
		</th>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%"><$style{font}><b>۷ :</b></font>
		</td>
		<td width="70%"><select name="conference">\n|;

	foreach (keys %$cat) { 
		$html_output .= "<option value=\"$_\">" . $cat->{$_}->{Name};
	}
	
	$html_output .= qq|</select></td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%"><$style{font}><b> ̸:</b></font>
		</td>
		<td width="70%"><input type="text" name="f_name" size="40"></td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%" valign="top"><$style{font}><b> :</b></font>
		</td>
		<td width="70%"><textarea wrap name="description" rows="3" cols="40" value=""></textarea></td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%" valign="top"><$style{font}><b> :</b></font>
		</td>
		<td width="70%"><$style{font}>
		<select name="f_type">
		<option value="public" selected> 
		<option value="member">ȸ 
		<option value="private"> 
		</select></font>
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%" valign="top"><$style{font}><b> :</b></font>
		</td>
		<td width="70%"><$style{font}>
		<input type="radio" name="status" value="On" checked> Ȱ 
		<input type="radio" name="status" value="Off"> Ȱ</font>
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%" valign="top"><$style{font}><b> :</b></font>
		</td>
		<td width="70%"><$style{font}>
		<input type="radio" name="moderation" value="On"> Ȱ 
		<input type="radio" name="moderation" value="Off" checked> Ȱ</font>
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%" valign="top"><$style{font}><b> :</b></font>
		</td>
		<td width="70%"><$style{font}>$output_mod</font>
		</td>
	</tr>
	<tr $style{bgcolor_title}>
		<td colspan="2">&nbsp;
		</td>
	</tr>
	<tr bgcolor="white">
		<td width="30%" valign="top">&nbsp;</td>
		<td width="70%"><br>
		<input type="submit" value=" ">
		<input type="reset" value="ʱ "></td>
	</tr>
	</table></form>|;

	$self->main_form($html_output);
}

sub ForumType {
	my %forum_type = (
			public		=> '',
			member		=> 'ȸ',
			private		=> ''
	);
	return $forum_type{$_[1]};
}

sub OnOff {
	my %onoff = (
			On	=> 'Ȱ',
			Off	=> 'Ȱ'
		);
	return $onoff{$_[1]};
}

sub SaveForum {
	my $self = shift;
	my $forum_id = 0;
	my $cat = $self->_read_cat();
	my @moderator = ();
	
	foreach (keys %$IN) {
		$IN->{$_} eq "moderator" and push @moderator, $_;
	}
	
	#----------------------------------------------------------------------
	#   ؽ ̺.
	#----------------------------------------------------------------------
	my %forum_type = (
			public		=> '0',
			member		=> '1',
			private		=> '9'
		);
	my %forum_info = (
			Description	=> $IN->{description},
			LastAuthor	=> '',
			LastTopic	=> '',
			LastTopicDate	=> '',
			LastTopicTime	=> '',
			MessageIcon	=> '',
			Moderator	=> [ @moderator ],
			Name		=> $IN->{f_name},
			Threads		=> '0',
			TotalTopic	=> '0',
			Type		=> $forum_type{$IN->{f_type}},
			ModerationB	=> $IN->{moderation},
			Status		=> $IN->{status}
		);
	
	#----------------------------------------------------------------------
	#  ID  .
	#----------------------------------------------------------------------
	
	if (-e "$CONFIG->{forum_path}/forum_id.txt") {
		open (FH, "$CONFIG->{forum_path}/forum_id.txt");
			flock(FH, 1);
			$forum_id = <FH> + 1;
		close FH;
		open (FH, ">$CONFIG->{forum_path}/forum_id.txt");
			flock(FH, 2);
			print FH $forum_id;
		close FH;
	}
	else { 
		open (FH, ">$CONFIG->{forum_path}/forum_id.txt");
			flock(FH, 2);
			$forum_id = 1;
			print FH $forum_id;
		close FH;
	}
	
	#----------------------------------------------------------------------
	#  丮     
	#----------------------------------------------------------------------

	if (! (-e "$CONFIG->{forum_path}/Forum$forum_id")) {
		mkdir ("$CONFIG->{forum_path}/Forum$forum_id", 0777);
		chmod (0777, "$CONFIG->{forum_path}/Forum$forum_id");
		mkdir ("$CONFIG->{data_directory}/pds/Forum$forum_id", 0777);
		chmod (0777, "$CONFIG->{data_directory}/pds/Forum$forum_id");
		mkdir ("$CONFIG->{public_directory}/pds/Forum$forum_id", 0777);
		chmod (0777, "$CONFIG->{public_directory}/pds/Forum$forum_id");
		
		open (FH, ">$CONFIG->{forum_path}/Forum$forum_id/topic.db");
			flock(FH, 2);
		close(FH);
		chmod (0666, "$CONFIG->{forum_path}/Forum$forum_id/topic.db");
		
		open (FH, ">$CONFIG->{forum_path}/Forum$forum_id/topic_id.txt");
			flock(FH, 2);
			print FH 0;
		close(FH);
		chmod (0666, "$CONFIG->{forum_path}/Forum$forum_id/topic_id.txt");
	}

	if (! (-e "$CONFIG->{forum_path}/Forum$forum_id.info") ) {
		$self->_write("$CONFIG->{forum_path}/Forum$forum_id.info", \%forum_info);
		chmod (0666, "$CONFIG->{forum_path}/Forum$forum_id.info");
	}
	
	#----------------------------------------------------------------------
	# ۷ Ͽ   ߰
	#----------------------------------------------------------------------

	push @{$cat->{$IN->{conference}}->{ForumList}}, "Forum" . $forum_id;
	$self->_write($CONFIG->{cat_file}, $cat);
	
	#----------------------------------------------------------------------
	#  ȭ .
	#----------------------------------------------------------------------

	my $conference = $cat->{$IN->{conference}}->{Name};
	my $result = "<BR><B>$IN->{c_name}   ϴ!</B>";
	my $forum_type = $self->ForumType($IN->{f_type});
	my $forum_status = $self->OnOff($IN->{status});
	my $mod_forum = $self->OnOff($IN->{moderation});
	
	$result .= qq|<BR><BR>
	<table border="0" cellpadding="2" cellspacing="1" width="100%">
	<tr>
		<td $style{bgcolor_title} colspan="2"><$style{font_title}><b>  </b></font>
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%"><$style{font}><b>۷ ̸:</b></font>
		</td><td width="70%"><$style{font}>$conference</font>
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%"><$style{font}><b> ̸:</b></font>
		</td><td width="70%"><$style{font}>$IN->{f_name}</font>
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%"><$style{font}><b> :</b></font>
		</td><td width="70%"><$style{font}>$IN->{description}</font>
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%"><$style{font}><b> :</b></font>
		</td><td width="70%"><$style{font}>$forum_type</font>
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%"><$style{font}><b> :</b></font>
		</td><td width="70%"><$style{font}>$forum_status</font>
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%"><$style{font}><b> :</b></font>
		</td><td width="70%"><$style{font}>$mod_forum</font>
		</td>
	</tr>
	<tr $style{bgcolor_title}>
		<td colspan="2"><$style{font}>&nbsp;
		</td>
	</table>|;
	
	$self->main_form($result);
}

sub DeleteForum {
	my $self = shift;
	
	my $html_output = qq|
	<form method="post">
	<input type="hidden" name="ch" value="Admin">
	<input type="hidden" name="do" value="DoDeleteForum">
	<table border="0" cellpadding="2" cellspacing="1" width="100%">
	<tr>
		<td colspan="4"><$style{font}><b>    մϴ.</b><br>
			<OL>
				<li>  ùڽ üũմϴ.
				      ֽϴ.</li>
			
				<li>" " ư ʽÿ.</li>
			</OL></font>
			<$style{font_red}>      ϴ.<BR>
			,  ȿ  ԵǾ    ͵  ˴ϴ.</font>
		</td>
	</tr>|;

	$html_output .= $self->ForumList("delete");
	$html_output .= qq|
		<tr>
			<td colspan="5" align="center"><BR>
			<input type="submit" value="  ">
			</td>
		</table></form>|;

	$self->main_form($html_output);
}

sub DoDeleteForum {
	my $self = shift;
	my ($delete_to_forum, $html_output, %delete_forum);
	my $cat = $self->_read_cat();

	foreach (%$IN) {
		if ($IN->{$_} eq "delete") {
			$delete_to_forum = 1;
		}
		$_ =~ /^(.*)-(.+)$/ and $delete_forum{$1} = $2;
	}
	
	my @update_forum;
	foreach my $forum (keys %delete_forum) {
		
		if (-e "$CONFIG->{forum_path}/$forum.info") {
			unlink("$CONFIG->{forum_path}/$forum.info") or 
				die("$CONFIG->{forum_path}/$forum.info   ϴ: $!\n");
		}
		if (-e "$CONFIG->{forum_path}/$forum") {
			DB->remove_directory("$CONFIG->{forum_path}/$forum");
		}
		if (-e "$CONFIG->{data_directory}/pds/$forum") {
			DB->remove_directory("$CONFIG->{data_directory}/pds/$forum");
		}
		if (-e "$CONFIG->{public_directory}/pds/$forum") {
			DB->remove_directory("$CONFIG->{public_directory}/pds/$forum");
		}
		
		LINE: foreach (@{$cat->{$delete_forum{$forum}}->{ForumList}}) {
			next LINE if $forum eq $_;
			push @update_forum, $_;
		}
		
		$cat->{$delete_forum{$forum}}->{ForumList} = [ @update_forum ];
	}
	
	$self->_write($CONFIG->{cat_file}, $cat);
	
	if ($delete_to_forum) {
		$html_output .= "<BR><$style{font}><B>   Ͽϴ!</B></font>";
	}
	else { $html_output = "<BR><$style{font}><B>  ϴ.</B></font>"; }

	$self->main_form($html_output);
}

sub ModifyForum {
	my $self = shift;
	
	my $html_output = qq|
	<form method="post">
	<input type="hidden" name="ch" value="Admin">
	<input type="hidden" name="do" value="DoModifyForum">
	<table border="0" cellpadding="2" cellspacing="1" width="100%">
	<tr>
		<td colspan="5"><$style{font}><b>    մϴ.</b><br>
			<OL>
				<li>  ùڽ üũմϴ.</li>
				<li>" " ư ʽÿ.</li>
			</OL></font>
		</td>
	</tr>|;

	$html_output .= $self->ForumList("modify");
	$html_output .= qq|
		<tr>
			<td colspan="5" align="center"><BR>
			<input type="submit" value="  ">
			</td>
		</table></form>|;

	$self->main_form($html_output);
}

sub DoModifyForum {
	my $self = shift;
	my $forum = DB->forum_data($IN->{modify});
	my ($uid, $output_mod, $html_output, %seen);
	my $users = DB->get_data("$CONFIG->{member_directory}/member_list.db");
	
	for (@{$forum->{Moderator}}) { $seen{$_}++; }
	
	foreach ( sort{ ${$users}{$a} cmp ${$users}{$b} } keys %$users) {
		$uid = $self->member_data($_);
		if ($uid->{MEMBER_LEVEL} > 2) {
			$output_mod .= qq~<input type="checkbox" name="$_" value="Moderator"~;
			$output_mod .= " checked" if $seen{$_};
			$output_mod .= ">$uid->{MEMBER_ID}";
			$output_mod .= "(" . $self->member_level($uid->{MEMBER_LEVEL}) . ")";
		}
	}
	
	unless ( exists($IN->{modify}) ) {
		$html_output = "<BR><$style{font}><B>  ϴ!</B></font>";
		return $self->main_form($html_output);
	}
	
	$html_output = qq|
	<form method="post">
	<input type="hidden" name="ch" value="Admin">
	<input type="hidden" name="do" value="SaveModifyForum">
	<input type="hidden" name="fid" value="$IN->{modify}">

	<table border="0" cellpadding="2" cellspacing="1" width="100%">
	<tr>
		<td colspan="2"><$style{font}><b>    մϴ.</b><br>
			<OL>
				<li> ̸  ׸  ɼ մϴ.</li>
				<li>Ͻ 뿡 ̻   Ȯ , " " ư ʽÿ.</li>
			</OL></font>
		</td>
	</tr>
	<tr $style{bgcolor_title}>
		<td colspan="2" align="center"><$style{font_title}><b> </b></font>
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td width="30%"><$style{font}><b> ̸:</b><font>
		</td><td width="70%"><input type="text" name="Name" value="$forum->{Name}" size="40"></td>
	</tr>
	<tr $style{bgcolor}>
		<td valign="top"><$style{font}><b> :</b><font>
		</td><td>
		<textarea wrap="virtual" rows="3" cols="40" name="Description">$forum->{Description}</textarea></td>
	</tr>
	<tr $style{bgcolor}>
		<td valign="top"><$style{font}><b> :</b><font>
		</td><td><select name="Type">\n|;
		for (@{$self->{forum_type}}) {
			$html_output .= "<option value=\"$_\"";
			$html_output .= " selected" if $_ == $forum->{Type};
			$html_output .= ">" . $self->forum_type($_) . "\n";
		}
	$html_output .= qq|</td></tr>
	<tr $style{bgcolor}>
		<td valign="top"><$style{font}><b> :</b><font>
		</td><td><$style{font}>|;
		for (@{$self->{onoff}}) {
			$html_output .= "<input type=\"radio\" name=\"Status\" value=\"$_\"";
			$html_output .= " checked" if $forum->{Status} eq $_;
			$html_output .= ">" . $self->OnOff($_) . "&nbsp;";
		}
	$html_output .= qq|</font></td></tr>
	<tr $style{bgcolor}>
		<td valign="top"><$style{font}><b> :</b><font>
		</td><td><$style{font}>|;
		for (@{$self->{onoff}}) {
			$html_output .= "<input type=\"radio\" name=\"ModerationB\" value=\"$_\"";
			$html_output .= " checked" if $forum->{ModerationB} eq $_;
			$html_output .= ">" . $self->OnOff($_) . "&nbsp;";
		}
	$html_output .= qq|</font></td></tr>
	<tr $style{bgcolor}>
		<td><$style{font}><b> :</b><font>
		</td><td><input type="text" name="TotalTopic" value="$forum->{TotalTopic}" size="6">
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td><$style{font}><b>б:</b><font>
		</td><td><input type="text" name="Threads" value="$forum->{Threads}" size="6">
		</td>
	</tr>
	<tr $style{bgcolor}>
		<td><$style{font}><b> :</b><font>
		</td><td><$style{font}>$output_mod</font>
		</td>
	</tr>
	<tr $style{bgcolor_title}>
		<td colspan="2">&nbsp;</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td><br><input type="submit" value=" "> <input type="reset" value="ʱ ">
		</td>
	</tr>
	</table>|;

	$self->main_form($html_output);
}

sub SaveModifyForum {
	my $self = shift;
	my $forum = DB->forum_data($IN->{fid});
	my @moderator = ();
	
	foreach (keys %$IN) {
		if ($IN->{$_} eq "Moderator") {
			push @moderator, $_; 
		}
		exists($forum->{$_}) and ($forum->{$_} = $IN->{$_}) or next;
	}

	$forum->{Moderator} = [ @moderator ];
	
	$self->_write("$CONFIG->{forum_path}/$IN->{fid}.info", $forum);
	
	my $html_output = "<BR><$style{font}><B>  Ǿϴ!<B></font>";
	$self->main_form($html_output);
}

sub MoveForum {
	my $self = shift;
	my ($idx, $bgcolor, $forum);
	
	my $html_output = qq|
	<form method="post">
	<input type="hidden" name="ch" value="Admin">
	<input type="hidden" name="do" value="SaveMoveForum">

	<table border="0" cellpadding="2" cellspacing="1" width="100%">
	<tr>
		<td colspan="3"><$style{font}><b>    ̵մϴ.</b><br>
			<OL>
				<li>̵ ۷ մϴ.</li>
				<li>" ̵" ư ʽÿ.</li>
			</OL></font>
		</td>
	</tr>
	<tr>
		<td $style{bgcolor_title} nowrap><$style{font_title}><b>̵ ۷ </b></font>
		</td>
		<td $style{bgcolor_title} nowrap><$style{font_title}><b> ̸</b></font>
		</td>
		<td $style{bgcolor_title}><$style{font_title}><b> </b></font>
		</td>
	</tr>|;
	
	$idx = 0;
	my $cat = $self->_read_cat();
	
	foreach my $conf (keys %$cat) {
		for (@{$cat->{$conf}->{ForumList}}) {
			$bgcolor = DB->color($idx);
			$forum = DB->forum_data($_);
			$html_output .= "<tr $bgcolor><td valign=\"top\"><select name=\"$_-$conf\">\n";
			$html_output .= $self->_cat_select($conf);
			$html_output .= qq|</select></td>
			<td valign="top"><$style{font}><b>$forum->{Name}</b></font>
			</td><td width="50%"><$style{font}>$forum->{Description}</font>
			</td></tr>|;
		}
		$idx++;
	}
	$html_output .= qq|<tr><td colspan="3" align="center"><BR>
		<input type="submit" value=" ̵"> <input type="reset" value="ʱ ">
		</td></tr></table>|;

	$self->main_form($html_output);
}

sub SaveMoveForum {
	my $self = shift;
	my (%move_forum, $html_output, @empty);
	my $cat = $self->_read_cat();

	foreach (%$IN) {
		$_ =~ /^(.*)-(.+)$/ and push @{$move_forum{$IN->{$_}}}, $1;
	}
	
	foreach (keys %$cat) {
		if (exists($move_forum{$_})) {
			$cat->{$_}->{ForumList} = [ sort @{$move_forum{$_}} ];
		}
		else { 
			$cat->{$_}->{ForumList} = [];
		}
	}
	$self->_write($CONFIG->{cat_file}, $cat);
	
	$html_output = "<BR><$style{font}><B>   ̵Ͽϴ!<B></font>";
	$self->main_form($html_output);
}

sub _read_cat { DB->get_data($CONFIG->{cat_file}); }

sub _cat_select {
	my ($self, $s) = @_;
	my $cat = $self->_read_cat();
	my $output;
	
	foreach (keys %$cat) {
		$output .= "<option value=\"$_\"";
		$output .= " selected" if $_ eq $s;
		$output .= ">" . $cat->{$_}->{Name}  . "\n";
	}
	
	return $output;
}
	
sub ForumList {
	my ($self, $s) = @_;
	my ($idx, $bgcolor, $forum_info, $forum_type, $onoff);
	my $cat = $self->_read_cat();
	
	my $html_output = qq|
	<tr>
		<th $style{bgcolor_title} nowrap><$style{font_title}><b></b></font>
		</th>
		<th $style{bgcolor_title} nowrap><$style{font_title}><b≯</b></font>
		</th>
		<th $style{bgcolor_title} width="50%"><$style{font_title}><b></b></font>
		</th>
		<th $style{bgcolor_title} nowrap><$style{font_title}><b></b></font>
		</th>
		<th $style{bgcolor_title} nowrap><$style{font_title}><b></b></font>
		</th>
	</tr>|;
	
	foreach my $conf (keys %$cat) {
		$idx = 0;
		
		$html_output .= qq|
		<tr>
		<td $style{bgcolor_title} colspan="5">
			<$style{font_title}><b>$cat->{$conf}->{Name} ۷</b></font>
		</td>
		</tr>| if (@{$cat->{$conf}->{ForumList}});
		
		for (@{$cat->{$conf}->{ForumList}}) {
			$bgcolor = DB->color($idx);
			$forum_info = DB->forum_data($_);
			$forum_type = $self->forum_type($forum_info->{Type});
			$onoff = $self->OnOff($forum_info->{Status});
			
			$html_output .= qq|
			<tr $bgcolor>
			<td align="center">|;
				if ($s eq "delete") {
					$html_output .= qq|<input type="checkbox" name="$_-$conf" value="$s">|;
				}
				else {
					$html_output .= qq|<input type="radio" name="$s" value="$_">|;
				}
			$html_output .= qq|
			</td>
			<td><$style{font}><b>$forum_info->{Name}</b></font>
			</td>
			<td><$style{font}>$forum_info->{Description}</font>
			</td>
			<td align="center"><$style{font}>$onoff</font>
			</td>
			<td><$style{font}>$forum_type</font>
			</td></tr>|;
			
			$idx++;
		}
		
	}
	return $html_output;
}

sub _userlist {
	my ($self, $action) = @_;
	my ($html_output, $value, $list, $user, $bgcolor, $count, $status);
	
	my %s = (
		ModifyMemberForm	=> '',
		DoDeleteMember		=> '',
		DoActivateMember	=> 'Ȱȭ',
		DoDeactivateMember	=> 'Ȱȭ'
	);
	
	$value = 	$action eq "DoActivateMember"	? "activate" 	:
			$action eq "DoDeactivateMember" ? "deactivate" 	: "delete";
	
	$list = DB->get_data("$CONFIG->{member_directory}/member_list.db");
	
	$html_output = qq|<form method="post">
	<input type="hidden" name="ch" value="Admin">
	<input type="hidden" name="do" value="$action">
	<table border="0" cellpadding="2" cellspacing="1" width="100%" bgcolor="$CONFIG->{forum_bgcolor}">
	<tr>
		<td colspan="7"><$style{font}><b>   ȸ $s{$action}մϴ.</b><br>
			<OL>
				<li>$s{$action}  ȸ մϴ.</li>
				<li>" ȸ $s{$action}" ư ʽÿ.</li>
			</OL></font>
		</td>
	</tr>
	<tr $style{bgcolor_title}>
		<td align="center"><$style{font_title}><b></b></font>
		</td><td><$style{font_title}><b>ȸ ID</b></font>
		</td><td><$style{font_title}><b≯</b></font>
		</td><td><$style{font_title}><b>з</b></font>
		</td><td><$style{font_title}><b></b></font>
		</td><td><$style{font_title}><b>ֱ </b></font>
		</td><td><$style{font_title}><b></b></font>
		</td>
	</tr>|;
	
	$count = 0;
	
	LINE:
	foreach (sort { $$list{$a} cmp $$list{$b} } keys %$list) {
		$user = DB->get_data("$CONFIG->{member_directory}/$_.cgi");
		
		next LINE if ($action eq "DoActivateMember" and $user->{STATUS});
		next LINE if ($action eq "DoDeactivateMember" and !$user->{STATUS});

		$user->{MEMBER_LEVEL} = $self->member_level($user->{MEMBER_LEVEL});
		$bgcolor = DB->color($count);
		$status = $user->{STATUS} ? 'Ȱ' : 'Ȱ';
		$html_output .= qq|<tr $bgcolor><td align="center">|;
		
			if ($action eq "ModifyMemberForm") {
				$html_output .= qq~<input type="radio" name="modify" value="$user->{USER_ID}">~;
			}
			else {
				$html_output .= qq~<input type="checkbox" name="$user->{USER_ID}" value="$value">~;
			}
			
			$html_output .= qq~
			</td><td><$style{font}><b>$user->{MEMBER_ID}</b></font>
			</td><td><$style{font}>$user->{NAME}</font>
			</td><td><$style{font}>$user->{MEMBER_LEVEL}</font>
			</td><td><$style{font}>$user->{CREATE_DATE}</font>
			</td><td><$style{font}>$user->{LAST_LOGIN}</font>
			</td><td><$style{font}>$status</font>
			</td></tr>~;
		
		$count++;
	}
	
	if ($count) {
		$html_output .= qq~<tr><td colspan="7" align="center">
			<br><input type="submit" value=" ȸ $s{$action}"></td></tr>
			</form></table>~;
		return $html_output;
	}
	else {
		return "<$style{font}><b>$s{$action}  ȸ ϴ.</b></font>";
	}

}

sub ModifyMember {
	my $self = shift;
	$self->main_form($self->_userlist("ModifyMemberForm"));
}

sub DeleteMember {
	my $self = shift;
	$self->main_form($self->_userlist("DoDeleteMember"));
}

sub ActivateMember {
	my $self = shift;
	$self->main_form($self->_userlist("DoActivateMember"));
}

sub DeactivateMember {
	my $self = shift;
	$self->main_form($self->_userlist("DoDeactivateMember"));
}

sub DoDeactivateMember {
	my $self = shift;
	my (@deactivate, $user, $html_output);

	foreach (keys %$IN) {
		$IN->{$_} eq "deactivate" and push @deactivate, $_;
	}
	
	foreach (@deactivate) {
		$user = $self->member_data($_);
		$user->{STATUS} = 0;
		$self->_write("$CONFIG->{member_directory}/$_.cgi", $user);

		if ($CONFIG->{auth_notify_user_on_activation}) {
			$self->notify_user_on_activation("deactivate", $user->{EMAIL}, $user->{MEMBER_ID});
		}
	}
	
	$html_output .= qq~<$style{font}><b> ȸ Ȱȭ ߽ϴ.</b></font>~;
	$self->main_form($html_output);
}

sub DoActivateMember {
	my $self = shift;
	my ($user, $html_output);
	my @activate = ();

	foreach (keys %$IN) {
		$IN->{$_} eq "activate" and push @activate, $_;
	}
	
	foreach (@activate) {
		$user = $self->member_data($_);
		$user->{STATUS} = 1;
		$self->_write("$CONFIG->{member_directory}/$_.cgi", $user);
		
		if ($CONFIG->{auth_notify_user_on_activation}) {
			$self->notify_user_on_activation("activate", $user->{EMAIL}, $user->{MEMBER_ID});
		}

	}

	$html_output = qq~<$style{font}><b> ȸ Ȱȭ ߽ϴ.</b></font>~;
	$self->main_form($html_output);
}

sub DoDeleteMember {
	my $self = shift;
	my (@delete_list, $list, $file, $html_output);

	foreach (%$IN) {
		$IN->{$_} eq "delete" and push @delete_list, $_;
	}
	
	$file = "$CONFIG->{member_directory}/member_list.db";
	$list = DB->get_data($file);
	
	foreach my $uid (@delete_list) {
		
		if ($CONFIG->{auth_notify_user_on_activation}) {
			my $user = $self->member_data($uid);
			$self->notify_user_on_activation("delete", $user->{EMAIL}, $user->{MEMBER_ID});
		}
		
		delete $list->{$uid};

		if (-e "$CONFIG->{member_directory}/$uid.cgi") {
			unlink "$CONFIG->{member_directory}/$uid.cgi";
		}
	}
	$self->_write($file, $list);
	
	$html_output = qq~<$style{font}><b>   Ͽϴ.</b></font>~;
	
	$self->main_form($html_output);
}

sub notify_user_on_activation {
	my ($self, $action, $email, $user) = @_;
	
	require CH::Mailer;
	my $tmp = 	$action eq "activate" 	? "Ȱȭ" 	: 
			$action eq "delete" 	? ""	: "Ȱȭ";
	
	my $subject = " ȸ  $tmp Ǿϴ.";
	my $msg = <<END_OF_MSG;
$subject
----------------------------------------------------------------------
 Email   $tmp Ǿ ˷帮   ڰ 帮 
EmailԴϴ.

 ְų   ø ڿ   ֽñ ٶϴ.

END_OF_MSG
	
	my $mailer = CH::Mailer->new (
			From		=> "  <$CONFIG->{admin_email}>",
			To		=> "$user <$email>",
			Encoding	=> 'Base64',
			Subject		=> $subject,
			Data		=> $msg,
			Type		=> 'TEXT',
		) or $self->error_msg("  ", "CH::Mailer !");
		
	$mailer->send() or $self->error_msg("  ", "CH::Mailer !");
}

sub ModifyMemberForm {
	my $self = shift;
	my ($html_output, $user, $id);
	
	$id = $IN->{modify};
	$user = $self->member_data($id);
	
	$html_output = qq~
	<form method="post">
	<input type="hidden" name="ch" value="Admin">
	<input type="hidden" name="do" value="SaveModifyMember">
	<input type="hidden" name="uid" value="$id">
	<table border="0" cellpadding="2" cellspacing="1" width="100%" bgcolor="$CONFIG->{forum_bgcolor}">
	<tr $style{bgcolor_title}>
		<td width="30%"><$style{font_title}><b>׸</b></font>
		</td><td width="70%"><$style{font_title}><b> </b></font>
		</td>
	</tr>
	<tr bgcolor="$CONFIG->{msg_box_color}">
		<td width="30%"><$style{font}><b>ȸ ID:</b></font>
		</td><td width="70%"><$style{font}>$user->{MEMBER_ID}</font>
		</td>
	</tr>
	<tr bgcolor="$CONFIG->{msg_box_color}">
		<td><$style{font}><b>йȣ:</b></font>
		</td><td><input type="password" name="password" size="30">
		</td>
	</tr>
	<tr bgcolor="$CONFIG->{msg_box_color}">
		<td><$style{font}><b>йȣ Ȯ:</b></font>
		</td><td><input type="password" name="password2" size="30">
		</td>
	</tr>
	<tr bgcolor="$CONFIG->{msg_box_color}">
		<td><$style{font}><b>EMail:</b></font>
		</td><td><input type="text" name="email" value="$user->{EMAIL}" size="30">
		</td>
	</tr>
	<tr bgcolor="$CONFIG->{msg_box_color}">
		<td><$style{font}><b>ȸ ̸:</b></font>
		</td><td><input type="text" name="name" value="$user->{NAME}" size="30">
		</td>
	</tr>
	<tr bgcolor="$CONFIG->{msg_box_color}">
		<td><$style{font}><b>ȸ з:</b></font>
		</td><td><select name="group">~;
		for (1, 2, 3, 9) {
			$html_output .= "<option value=\"$_\"";
			$html_output .= " selected" if $user->{MEMBER_LEVEL} eq $_;
			$html_output .= ">" . $self->member_level($_) . "\n";
		}
	$html_output .= qq~</select></td></tr>
	<tr bgcolor="$CONFIG->{msg_box_color}">
		<td><$style{font}><b> :</b></font>
		</td><td><$style{font}>~;
		for (0, 1) {
			my $status = $_ ? 'Ȱ' : 'Ȱ';
			$html_output .= qq~<input type="radio" name="status" value="$_"~;
			$html_output .= " checked" if $user->{STATUS} eq $_;
			$html_output .= ">$status";
		}
	$html_output .= qq~</font></td></tr>
	<tr $style{bgcolor_title}><td colspan="2">&nbsp;</td></tr>
	<tr>
		<td>&nbsp;</td>
		<td><br>
		<input type="submit" value=" Ȯ"> <input type="reset" value="">
	</td></tr></form></table>~;
	
	$self->main_form($html_output);
}

sub SaveModifyMember {
	my $self = shift;
	my ($html_output, $user, $uid, $file, $passwd, $check);
	$uid = $IN->{uid};
	$user = $self->member_data($uid);

	$check = FormCheck->new;
	$check->verify_multi (
			[
				{
					-name		=> 'email',
					-msg_name	=> 'E-Mail',
					-value		=> $IN->{email},
					-type		=> 'email'
				},
			],
		);
	
	if ($IN->{password} ne $IN->{password2}) {
		$self->error_msg("Է ", "йȣ ġ ʽϴ.");
	}
	
	if ($check->errors) {
		$self->error_msg("Է ", $check->errors);
	}
	
	$passwd = $IN->{password} ? DB->encrypt($IN->{password}) : $user->{PASSWORD};
	
	$user->{NAME} = $IN->{name};
	$user->{MEMBER_LEVEL} = $IN->{group};
	$user->{STATUS} = $IN->{status};
	$user->{EMAIL} = $IN->{email};
	$user->{PASSWORD} = $passwd;
	
	$self->_write("$CONFIG->{member_directory}/$uid.cgi", $user);
	$html_output = qq~<$style{font}>
		<b>'$user->{MEMBER_ID}' ȸ   Ǿϴ.</b></font>~;

	$self->main_form($html_output);
}

sub WriteAnnounce {
	my $self = shift;
	my $html_output = '';
	my $write_time = DB->current_date();

	$html_output = qq|
	<form method="post">
	<input type="hidden" name="ch" value="Admin">
	<input type="hidden" name="do" value="SaveAnnounce">
	<table border="0" cellpadding="2" cellspacing="1" width="100%" bgcolor="$CONFIG->{forum_bgcolor}">
	<tr $style{bgcolor_title}>
		<td colspan="2"><$style{font_title}><b> </b></font>
		</td>
	</tr>
	<tr bgcolor="$CONFIG->{msg_box_color}">
		<td width="30%"><$style{font}><b>:</b></font>
		</td><td width="70%"><input type="text" name="subject" size="50"></td>
	</tr>
	<tr bgcolor="$CONFIG->{msg_box_color}"><td valign="top"><$style{font}><b>:</b></font>
		</td><td><textarea wrap="virtual" rows="15" cols="50" name="body"></textarea>
		</td>
	</tr>
	<tr bgcolor="$CONFIG->{msg_box_color}">
		<td width="30%"><$style{font}><b>ۼ ð:</b></font>
		</td><td><$style{font}>$write_time</font>
		</td>
	</tr>
	<tr>
		<td colspan="2" align="center">
		<br><input type="submit" value=" ">
		<input type="reset" value="ٽ ۼ">
		</td>
	</tr>
	</table></form>|;
	
	$self->main_form($html_output);
}

sub SaveAnnounce {
	my $self = shift;
	my $html_output = "";
	my $file = "$CONFIG->{data_directory}/announcements.cgi";
	
	my %announce = (
		subject => DB->text_trim($IN->{subject}),
		body	=> DB->message_check($IN->{body}),
		date	=> DB->current_date()
	);
	
	my $data = DB->get_data($file);
	$data->{ DB->sort_time() } = { %announce };
	$self->_write($file, $data);
	
	$html_output = qq|
		<table border="0" cellpadding="2" cellspacing="1" width="100%">
		<tr $style{bgcolor_title}><td colspan="2">
		<$style{font_title}><b>   Ǿϴ.</b></font>
		</td></tr>
		<tr bgcolor="$CONFIG->{msg_box_color}">
			<td width="20%"><$style{font}><b>:</b></font>
			</td><td width="80%"><$style{font}>$announce{subject}</font>
			</td>
		</tr>
		<tr bgcolor="$CONFIG->{msg_box_color}">
			<td><$style{font}><b>ۼ:</b></font>
			</td><td><$style{font}>$announce{date}</font>
			</td>
		</tr>
		<tr bgcolor="$CONFIG->{msg_box_color}">
			<td colspan="2">
			<$style{font}><blockquote>$announce{body}</blockquote></font>
		</td></tr></table>|;

	$self->main_form($html_output);
}

sub ModifyAnnounce {
	my $self = shift;
	my $html_output = "";
	my $data = DB->get_data("$CONFIG->{data_directory}/announcements.cgi");
	
	if (keys %$data > 0) {
		$html_output = qq|<form method="post">
			<input type="hidden" name="ch" value="Admin">
			<input type="hidden" name="do" value="ModifyAnnounceForm">
			<table border="0" cellpadding="2" cellspacing="1" width="100%">
			<tr $style{bgcolor_title}>
				<td align="center"><$style{font_title}><b></b></font>
				</td><td><$style{font_title}><b>ۼ</b></font>
				</td><td><$style{font_title}><b></b></font>
				</td>
			</tr>|;
	
		my $count = 0;
		foreach (sort {$b <=> $a} keys %$data) {
			my $bgcolor = DB->color($count);
			$html_output .= qq|<tr $bgcolor><td align="center">
			<input type="radio" name="modify" value="$_"></td>
			<td><$style{font}>$data->{$_}->{date}</font>
			</td><td><$style{font}>$data->{$_}->{subject}</font>
			</td></tr>|;
			$count++;
		}
		$html_output .= "</table><br><input type=\"submit\" value=\"  \"></form>";
	}
	else { 
		$html_output = "<$style{font}><b>  ϴ.</b></font>";
	}

	$self->main_form($html_output);
}

sub ModifyAnnounceForm {
	my $self = shift;
	my $data = DB->get_data("$CONFIG->{data_directory}/announcements.cgi");
	my $subject = DB->msg_to_form($data->{$IN->{modify}}->{subject});
	my $body = DB->msg_to_form($data->{$IN->{modify}}->{body});
	
	my $html_output = qq|
	<form method="post">
	<input type="hidden" name="ch" value="Admin">
	<input type="hidden" name="do" value="SaveModifyAnnounce">
	<input type="hidden" name="key" value="$IN->{modify}">
	
	<table border="0" cellpadding="2" cellspacing="1" width="100%" bgcolor="$CONFIG->{forum_bgcolor}">
	<tr $style{bgcolor_title}>
		<td colspan="2"><$style{font_title}><b> </b></font>
		</td>
	</tr>
	<tr bgcolor="$CONFIG->{msg_box_color}">
		<td width="30%"><$style{font}><b>:</b></font>
		</td><td width="70%"><input type="text" name="subject" size="50" value="$subject">
		</td>
	</tr>
	<tr bgcolor="$CONFIG->{msg_box_color}">
		<td valign="top"><$style{font}><b>:</b></font>
		</td><td><textarea wrap="virtual" rows="15" cols="50" name="body">$body</textarea>
		</td>
	</tr>
	<tr bgcolor="$CONFIG->{msg_box_color}">
		<td width="30%"><$style{font}><b>ۼ ð:</b></font>
		</td><td width="70%"><$style{font}>$data->{$IN->{modify}}->{date}</font>
		</td>
	</tr>
	<tr>
		<td colspan="2" align="center"><br><input type="submit" value=" ">
		<input type="reset" value="ٽ ۼ">
		</td>
	</tr></table></form>|;
	
	$self->main_form($html_output);
}	

sub SaveModifyAnnounce {
	my $self = shift;
	my $html_output = "";
	my $file = "$CONFIG->{data_directory}/announcements.cgi";
	my $data = DB->get_data($file);
	my %announce = (
		subject => DB->text_trim($IN->{subject}),
		body	=> DB->message_check($IN->{body}),
		date	=> $data->{$IN->{key}}->{date}
	);
	
	$data->{$IN->{key}} = { %announce };
	$self->_write($file, $data);
	
	$html_output = qq|
		<table border="0" cellpadding="2" cellspacing="1" width="100%">
		<tr $style{bgcolor_title}>
			<td colspan="2"><$style{font_title}><b> Ǿϴ.</b></font>
			</td>
		</tr>
		<tr bgcolor="$CONFIG->{msg_box_color}">
			<td width="20%"><$style{font}><b>:</b></font>
			</td><td width="80%"><$style{font}>$announce{subject}</font>
			</td>
		</tr>
		<tr bgcolor="$CONFIG->{msg_box_color}">
			<td><$style{font}><b>ۼ:</b></font>
			</td><td><$style{font}>$announce{date}</font>
			</td>
		</tr>
		<tr bgcolor="$CONFIG->{msg_box_color}">
			<td colspan="2"><$style{font}><blockquote>$announce{body}</blockquote></font>
		</td></tr></table>|;

	$self->main_form($html_output);
}

sub DeleteAnnounce {
	my $self = shift;
	my $html_output;
	my $data = DB->get_data("$CONFIG->{data_directory}/announcements.cgi");
	
	if (keys %$data > 0) {
		$html_output = qq|<form method="post">
			<input type="hidden" name="ch" value="Admin">
			<input type="hidden" name="do" value="DoDeleteAnnounce">
			<table border="0" cellpadding="2" cellspacing="1" width="100%">
			<tr $style{bgcolor_title}>
				<td align="center"><$style{font_title}><b></b></font>
				</td><td><$style{font_title}><b>ۼ</b></font>
				</td><td><$style{font_title}><b></b></font>
				</td>
			</tr>|;
	
		my $count = 0;
		foreach (sort {$b <=> $a} keys %$data) {
			my $bgcolor = DB->color($count);
			$html_output .= qq|<tr $bgcolor><td align="center">
				<input type="checkbox" name="$_" value="delete"></td>
				<td><$style{font}>$data->{$_}->{date}</font>
				</td><td><$style{font}>$data->{$_}->{subject}</font>
				</td></tr>|;
			$count++;
		}
		$html_output .= "</table><br><input type=\"submit\" value=\"  \"></form>";
	}
	else { 
		$html_output = "<$style{font}><b>  ϴ.</b></font>";
	}
	
	$self->main_form($html_output);
}

sub DoDeleteAnnounce {
	my $self = shift;
	my @delete_list;
	
	foreach (keys %$IN) { 
		$IN->{$_} eq "delete" and push @delete_list, $_;
	}
	
	my $file = "$CONFIG->{data_directory}/announcements.cgi";
	my $data = DB->get_data($file);
	
	my $html_output = "<$style{font}><b>   Ͽϴ.</b></font><p>";
	
	for (@delete_list) {
		$html_output .= "<li>" . $data->{$_}->{subject} . "<br>";
		delete $data->{$_};
	}
	
	$self->_write($file, $data);
	$self->main_form($html_output);
}

sub MailNews {
	my $self = shift;
	my ($html_output, $user);
	my $user_list = DB->get_data("$CONFIG->{member_directory}/member_list.db");
	
	$html_output = qq|
		<form method="post">
		<input type="hidden" name="ch" value="Admin">
		<input type="hidden" name="do" value="SendMailNews">
		<table border="0" cellpadding="2" cellspacing="1" width="100%">
		<tr>
		<td colspan="2"><$style{font}><b>   ȸ鿡  ϴ.</b><br>
			<OL>
				<li>޴   ü ȸ ⺻ õǾ ֽϴ.
				ġ ʴ ּҴ Ű 'Ctrl' Ű  ¿ ش
				 ּҸ ŬϿ  ¸ Ͻʽÿ.
				</li>
				<li>  ۼ ,    Ͻð  ⸦ Ͻʽÿ.
				, ߺǴ  ּҰ       ˴ϴ.</li>
			</OL>
			:  'HTML'   ,  HTML  ۼϿ ʽÿ.<br>
			HTML    ̿Ͽ ۼ  Ͽ ̱ Ͻø մϴ.
			</font>
		</td>
		</tr>
		<tr $style{bgcolor_title}>
			<td colspan="2" valign="top"><$style{font_title}><b>ȸ ϴ </b></font>
			</td>
		</tr>
		<tr bgcolor="$CONFIG->{msg_box_color}">
			<td valign="top" nowrap><$style{font}><b>޴ :</b></font>
			</td><td>
			<select name="mailto" multiple size="5">\n|;
	my $total = 0;
	foreach (sort {$$user_list{$a} cmp $$user_list{$b}} keys %$user_list) {
		$user = DB->get_data("$CONFIG->{member_directory}/$_.cgi");
		$html_output .= "<option selected>$user->{EMAIL}\n";
		$total++;
	}

	$html_output .= qq|</select><$style{font}>  <b>$total</b> .
		</td></tr>
		<tr bgcolor="$CONFIG->{msg_box_color}">
			<td><$style{font}><b>:</b></font>
			</td><td><input type="text" name="subject" size="60">
			</td>
		</tr>
		<tr bgcolor="$CONFIG->{msg_box_color}">
			<td valign="top"><$style{font}><b>:</b></font>
			</td><td><textarea name="message" cols="60" rows="10"></textarea></td>
		</tr>
		<tr bgcolor="$CONFIG->{msg_box_color}">
			<td><$style{font}><b> :</b></font>
			</td><td>
				<select name="type">
				<option value="HTML">HTML 
				<option value="TEXT" selected>TEXT 
				</select>
			</td>
		</tr>
		<tr $style{bgcolor_title}>
			<td colspan="2">&nbsp;</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td><br><input type="submit" value=" "> <input type="reset" value="">
			</td>
		</tr></form>
		</table>|;

	$self->main_form($html_output);
}

sub SendMailNews {
	use CGI();
	use CH::Mailer();

	my $self = shift;
	my $q = new CGI;
	my ($html_output, $start);
	my $subject = $q->param('subject');
	my $message = $q->param('message');
	my @mailto = $q->param('mailto');
	my $mail_type = $q->param('type');
	my %seen = ();
	my $mailer;
	my $admin_menu = qq|<b>[<a href="index.cgi?ch=Admin"> ƿƼ ưϴ.</a>]</b>\n\n|;

	$start = time();
	
	print $q->header(), $q->start_html(-title => 'CHBoard Admin: ϴ '), "<pre>";
	
	print $admin_menu;
	$subject or print " Է ʾҽϴ." and return;
	$message or print " Է ʾҽϴ." and return;
	print '  : ', scalar localtime($start), "\n\n";
	
	foreach my $address (@mailto) {
		$seen{$address}++ and print "<li>$address ߺǴ ּԴϴ. ǳ ݴϴ.\n" and next;
		$mailer = CH::Mailer->new (
			From	=> $CONFIG->{admin_email},
			To	=> $address,
			Subject	=> $subject,
			Data	=> $message,
			Encoding=> 'Base64',
			Type	=> $mail_type,
		) or (print '  ') and next;

		$mailer->send() ? print qq|<li>$address   Ϸ!\n| :
			print qq|<li>$_   !\n|;
	}

	my $finish = time();
	my $elspsed = $finish - $start;
	print "-" x 69, "\n";
	print "  Ϸ: ", scalar localtime($finish), "\nɸð: $elspsed \n\n";
	print $admin_menu;
	print "</pre>", $q->end_html(), "\n\n" if (defined $q);
	exit(0);
}

sub system_info {
	my $self = shift;
	my $html_output .= qq~<table border="0" cellpadding="0" cellspacing="0" width="100%">
		<tr><td>~;
	$html_output .= $self->display_system();
	$html_output .= "</td></tr></table>";
	
	$self->main_form($html_output);
}

sub main_form {
	my ($self, $contents) = @_;
	my $output = qq~<html><head>
	<title>CHBoard Admin Util</title>
	</head>
	<LINK HREF="$CONFIG->{public_url}/style.css" REL=STYLESHEET TYPE="TEXT/CSS">
	<body bgcolor="white">
		$table_top
		<table border="0" cellpadding="0" cellspacing="0" width="100%">
		<tr $style{bgcolor_title}>
			<td height="50">
			<font size="5" face="verdana" color="white">&nbsp;<b>CHBOARD ADMIN $VERSION</b></font>
		</td>
			<td align="right">
			<font size="2" color="white"><a href="index.cgi?ch=Admin"></a> | 
			<a href="http://www.koinweb.co.kr/perl/chboard/index.cgi"></a>&nbsp;</font>
			</td>
		</tr>
		</table>
		$table_bottom
		
		<table border="0" cellpadding="0" cellspacing="0" width="100%">
		<tr><td height="5" colspan="3"><$style{spacer}></td></tr>
		<tr><td colspan="3">
		$table_top
		<table border="0" cellpadding="2" cellspacing="0" width="100%">
		<tr><td bgcolor="$CONFIG->{msg_box_color}">
		<$style{font}><img src="$CONFIG->{images_url}/home.gif" align="absmiddle">
		<a href="index.cgi">ó</a> >  </font>
		</td></tr></table>
		$table_bottom

		</td></tr>
		<tr><td height="5" colspan="3"><$style{spacer}></td></tr>
		<tr><td width="150" valign="top" bgcolor="#EEEEEE">~;
	
		$output .= $SIDE_MENU;

		$output .= <<END_OF_HTML;
		</td><td>&nbsp;&nbsp;</td>
		<td valign="top" bgcolor="#ffffff" align="center">
		$contents
		</td></tr></table>
		<BR>
		$table_top
		<table border="0" cellpadding="7" cellspacing="0" width="100%">
			<tr bgcolor="white">
			<td align="center">
			<font size="2">$CONFIG->{copyright}</font>
			</td></tr>
		</table>
		$table_bottom
		</body></html>
END_OF_HTML

}

$table_top = <<TABLE_TOP;
	<table border="0" cellpadding="1" cellspacing="0" width="100%">
		<tr>
		<td bgcolor="$CONFIG->{table_border_color}">
TABLE_TOP

$table_bottom = <<TABLE_BOTTOM;
		</td></tr></table>
TABLE_BOTTOM

sub _write {
	my ($self, $file, $data) = @_;

	open(FH, ">$file") or die("$file  ͸   ϴ. : $!\n");
		flock(FH, 2);
		print FH $self->license_msg();
		print FH CH::Dumper->dump( 
				data 	=> $data, 
				var 	=> '' 
				);
	close(FH);
	chmod 0666, $file;
}

#----------------------------------------------------------------------
