#       	    --------------------------
#           	             CHBoard
#		    --------------------------
#
#     : âȣ.
#       : contact@koinweb.co.kr
#   Ȩ: http://www.koinweb.co.kr
#       : Base.pm
#
# Copyright (C) 2001 Koinweb - All rights reserved.
#  α׷  Ǿ   ϰų  
# Ǹ  ϴ.
#
#===================================================================

package CH::Base;
#-------------------------------------------------------------------
use strict;

sub new {
	my $this = shift;
	my $params = (@_ && UNIVERSAL::isa($_[0], 'HASH')) ? shift : { @_ };
	my $self = bless { _ERROR => '' }, $this;

	return $self->_init($params) ? $self : $this->error($self->error);
}

sub _init {
	my ($self, $config) = @_;
	return $self;
}

sub error {
	my $self = shift;
	my $errvar;

	{
		no strict qw/refs/;
		$errvar = ref $self ? \$self->{ _ERROR } : \${ "$self\::ERROR" };
	}

	if (@_) {
		$$errvar = ref($_[0]) ? shift : join('', @_);
		return undef;
	}
	else {
		return $$errvar;
	}
}

#----------------------------------------------------------------------
1;
