package Plugins::AttachFile;

use strict;
use base qw(CH::Base);
use Setup qw($CONFIG);
use CH::DBUtil;
use CH::Getform;

sub _init() {
	my $class = shift;
	my ($buffer, $read, $dir);
	if ($IN->{d}) {
		my ($id, undef) = split /-/, $IN->{ID};
		my $file ="$CONFIG->{data_directory}/pds/$IN->{b}/$id.cgi";
		my $data = DB->get_data($file);
		
		$data->{DOWNLOAD}++;
		DB->_dumper($file, $data);
		
		$dir = "$CONFIG->{public_directory}/pds/$IN->{b}";
	}
	else {	$dir = "$CONFIG->{public_directory}/files"; }
		
	my $file = "$dir/$IN->{ID}" . ".file";

	print "Content-Type: application/octet-stream; name=$IN->{f}\n";
	print "Content-Disposition: inline; filename=$IN->{f}\n\n";

	open (FILE, $file);
		while ($read = read (*FILE, $buffer, 1024)) {
			print $buffer;
		}
	close FILE;
	
	exit(0);
}
#----------------------------------------------------------------------
1; #  ʽÿ.
