package Plugins::EditPost;

#----------------------------------------------------------------------
# ʿ  Ѵ.
use strict;
use Setup qw/$CONFIG/;
use CH::Getform;
use CH::DBUtil;
use vars qw/@ISA/;

@ISA = qw/Board/; # Board Ŭ Ѵ.

#----------------------------------------------------------------------
#
#
sub new {
	my $self = bless {};
	my $err_msg = "";

	# ͸ Ǵ α  ʾ ,  ޽ ϰ .
	unless ($MEMBER->login_name()) { $SESSION->member_login; }
	
	#  ش  DB  , 迭 Ѵ.
	my @data_line = ();
	open (FH, "<$CONFIG->{forum_path}/$IN->{b}/$IN->{t}.cgi");
		flock (FH, 1);
		LINE: while (<FH>) {

			# 亯 ȣ ã ش ϰ  .
			/^REPLY.$IN->{omm}/ and @data_line = DB->data_split($_) and last LINE;
		}
	close FH;
	
	my $edit_permission = $self->edit_permission($IN->{b});
	
	#  ۼ  ƴ   ޽ ϰ .
	unless ($data_line[4] eq $MEMBER->login_name or $edit_permission) { 
		my $msg = "  <B>" . $MEMBER->login_name . "</B>    ƴմϴ.";
		$self->error_msg(" ", $msg);
	}
	
	$self->{subject} = $data_line[2]; 			#  .
	$self->{message} = $data_line[3]; 			#   .
	$self->{date_time} = "$data_line[5], $data_line[6]"; 	# ¥, ð .
	
	if (@_) {
		$self->{TEMPLATE} = DB->load_template("edit_post.html");
		$self->{TEMPLATE}->param( DB->style_vars(" ϱ($self->{subject}") );
		$self->_initialize(@_);
		$self->{TEMPLATE}->output;
	} else { return 0; }
}

#----------------------------------------------------------------------
#
#
sub _initialize {
	my $self = shift;

	#   ´.
	my $forum_info = DB()->get_data("$CONFIG->{forum_path}/$IN->{b}.info");
	my $uid = $MEMBER->USER_ID(); # ȸ ID ´.
	my $target = $self->target();
	my $poster = $MEMBER->login_name();

	#  ± .
	my $hidden_tag = <<END_OF_TAG;
	<input type="hidden" name="ch" value="Forum">
	<input type="hidden" name="do" value="WriteEdit">
	<input type="hidden" name="cid" value="$IN->{cid}">
	<input type="hidden" name="b" value="$IN->{b}">
	<input type="hidden" name="t" value="$IN->{t}">
	<input type="hidden" name="omm" value="$IN->{omm}">
	<input type="hidden" name="Author" value="$poster">
	<input type="hidden" name="UserID" value="$uid">
	<input type="hidden" name="target" value="$target">
END_OF_TAG
	
	my $html_use = "On"; 
	my $ch_code = "Off";
	
	if ($CONFIG->{use_chcode}) { $html_use = "Off"; $ch_code = "On"; }
	
	my $use_tag = "HTML ± : $html_use<br>CH ڵ : $ch_code<br>";
	my $mailer = '<BR><INPUT TYPE="CHECKBOX" NAME="Mailer" VALUE="1" CHECKED> - 亯 ϵǸ 
			  ðڽϱ?';
	my $content_type = "<FORM ACTION=\"index.cgi\" NAME=\"WritePost\" METHOD=\"POST\">";
	
	if ($CONFIG->{attach}) {
		$content_type = "<FORM ACTION=\"index.cgi\" NAME=\"WritePost\" METHOD=\"POST\" ENCTYPE=\"multipart/form-data\">";
	}

	#øƮ  ش  .
	$self->{TEMPLATE}->param( 
		mailer		=> $mailer,
		hidden_tag	=> $hidden_tag,		#   ± .
		forum_name	=> $forum_info->{Name}, #  ̸ .
		poster		=> $poster, 		# ۾ ̸ .
		message_icons	=> DB->message_icon("gif"), # ޽  .
		subject 	=> DB->msg_to_form($self->{subject}),
		date_time	=> $self->date_time(),
		use_tag		=> $use_tag,
		nav_bar		=> $self->navigation_bar(__PACKAGE__, $IN->{cid}, $IN->{b}) . " ϱ",
		message		=> DB->msg_to_form($self->{message}),
		jscript		=> DB->JSEmotion_CHCode(),
		content_type	=> $content_type,
		emotion_chcode	=> DB->emotion_chcode() );
}

#----------------------------------------------------------------------
