package Plugins::EmailToFriend;

use strict;
use Setup qw($CONFIG, $VARS);
use CH::Getform;
use CH::DBUtil;
use vars qw(@ISA);

@ISA = qw(Board);

#----------------------------------------------------------------------
#
#
#----------------------------------------------------------------------

sub new {
	bless my $self = {};
	
	if ($MEMBER->login_name()) {
		$self->{TEMPLATE} = DB->load_template("emailto_friend.html");
		($IN->{action} eq "send") ? $self->sendmail : $self->sendform;
	}
	else { $SESSION->member_login(); }
}

#----------------------------------------------------------------------
#
#
#----------------------------------------------------------------------

sub sendform {
	my $self = shift;
	my $from_name = $MEMBER->MEMBER_ID();
	my $from_email = $MEMBER->EMAIL();
	my @topic_array = ();

	open (FILE, "$CONFIG->{forum_path}/$IN->{b}/$IN->{t}.cgi") 
		or $self->error_msg("  ", ": $!");
		flock(FILE, 1);
		LINE: while (<FILE>) {
			/^TOPIC/ ? (@topic_array = DB->data_split($_)) : last LINE;
		}
	close FILE;
	
	my ($topic, $author) = splice(@topic_array, 1, 2);

	my $html_output = <<"END_OF_HTML";
	<table $VARS->{table}>
	<tr><td><$VARS->{font}>
		/ ̿Ͽ       ּҸ  Ͻʽÿ.
		<BR>,  ÷εǾ  ,  ۵ ʽϴ.</font>
		</td></tr>
	</table>
	
	<form method="post">
	<input type="hidden" name="ch" value="Forum">
	<input type="hidden" name="cid" value="$IN->{cid}">
	<input type="hidden" name="b" value="$IN->{b}">
	<input type="hidden" name="t" value="$IN->{t}">
	<input type="hidden" name="do" value="EmailToFriend">
	<input type="hidden" name="action" value="send">
	<input type="hidden" name="from_name" value="$from_name">
	<input type="hidden" name="from_email" value="$from_email">
	
	$VARS->{table_top}
		<table $VARS->{table}>
		<tr $VARS->{bg_header}>
			<td colspan="2"><$VARS->{header_font}><b>б Ϸ մϴ.</b></font>
			</td>
		</tr>
		<tr $VARS->{bg_color1}>
			<td width="25%"><$VARS->{font}> б:</font>
			</td>
			<td width="75%"><$VARS->{font}><b>$topic</b> ($author)</font>
			</td>
		</tr>
		<tr $VARS->{bg_color2}>
			<td width="25%"><$VARS->{font}>޴  E-mail:</font>
			</td>
			<td width="75%"><input type="text" name="to" size="27">
			</td>
		</tr>
		<tr $VARS->{bg_color1}>
			<td width="25%"><$VARS->{font}> :</font>
			</td>
			<td width="75%"><$VARS->{font}>$from_name <$from_email></font>
			</td>
		</tr>
		<tr $VARS->{bg_color2}>
			<td width="25%"><$VARS->{font}> (Cc):</font>
			</td>
			<td width="75%"><input type="text" name="cc"> <$VARS->{font}>(ɼ)</font>
			</td>
		</tr>
		<tr $VARS->{bg_color1}>
			<td width="25%"><$VARS->{font}>(Bcc):</font>
			</td>
			<td width="75%"><input type="text" name="bcc"> <$VARS->{font}>(ɼ)</font>
			</td>
		</tr>
		<tr $VARS->{bg_color2}>
			<td width="25%"><$VARS->{font}> :</font>
			</td>
			<td width="75%"><input type="text" name="subject" size="30">
			<select name="mailtype">
			<option value="text">Ϲ ؽƮ </option>
			<option value="html" selected>HTML </option>
			</select> <$VARS->{font}>(ɼ)</font>
			</td>
		</tr>
		<tr $VARS->{bg_color1}>
			<td valign="top"><$VARS->{font}>ٿ  :</font></td>
			<td>
			<textarea wrap="virtual" name="message" rows="10" cols="50"></textarea>
			</td>
		</tr>
		</table>
	$VARS->{table_bottom}
	$VARS->{spacer}

	<table $VARS->{table}>
	<tr>
	<td align="center"><input type="submit" value=" "> <input type="reset" value="ٽ ۼ">
	</td></tr>
	</table>
	</form>
END_OF_HTML
	
	$self->{TEMPLATE}->param( DB->style_vars("б Ϸ ϱ") );
	$self->{TEMPLATE}->param(
				nav_bar 	=> $self->navigation_bar("ReadPost", $IN->{cid}, $IN->{b}) . "б Ϸ ",
				html_output	=> $html_output,
			);
	return $self->{TEMPLATE}->output;
}

#----------------------------------------------------------------------
#
#
#----------------------------------------------------------------------

sub sendmail {
	my $self = shift;
	
	unless ($IN->{to} and $IN->{to} =~ m/[\w\d\.-]+\@[\w\d\.-]+/) {
		$self->error_msg("޴  E-mail Է !", "޴   ּҰ ٸ ʽϴ.");
	}
	
	my $field_name = $self->readpost_field();
	my $threads = DB->read_threads($IN->{b}, "$IN->{t}.cgi", $field_name);
	
	my $msg_body = "";
	my $end = @$threads;
	
	$msg_body .= qq|<html><body><$VARS->{font}><b>
		<A HREF="$CONFIG->{base_url}/index.cgi?ch=Forum&do=ReadPost&cid=$IN->{cid}&b=$IN->{b}&t=$IN->{t}">⸦ Ŭϸ б URL ̵մϴ.</A></b></font>
		<table $VARS->{table}>| if uc $IN->{mailtype} eq "HTML";
	
	foreach (0 .. $end-1) {
		my %result = %{$threads->[$_]};
		my $bgcolor = DB->color($_);

		if (uc $IN->{mailtype} eq "HTML") {
			$msg_body .= qq|
				<tr $VARS->{bg_header}>
					<td colspan="2"><$VARS->{header_font}><b> </b></font>
					</td>
				</tr>| if $result{THREADNO} == 0;

			$msg_body .= qq| 
				<tr $bgcolor>
					<td width="20%"><$VARS->{font}><b>:</b></font>
					</td>
					<td width="80%"><$VARS->{font}><b>$result{SUBJECT}</b></font>
					</td>
				</tr>
				<tr $bgcolor>
					<td><$VARS->{font}><b>۾:</b></font>
					</td>
					<td><$VARS->{font}>$result{AUTHOR}</font>
					</td>
				</tr>
				<tr $bgcolor>
					<td><$VARS->{font}><b>¥</b></font>
					</td>
					<td><$VARS->{font}>$result{DATE}<font>, <$VARS->{font_time}>$result{TIME}</font>
					</td>
				</tr>
				<tr $bgcolor>
					<td colspan="2">
					<blockquote><$VARS->{font}>$result{MESSAGE}</font></blockquote>
					</td>
				</tr>|;
		}
		else { 
			$result{MESSAGE} = DB->msg_to_form($result{MESSAGE});
			$result{SUBJECT} = DB->msg_to_form($result{SUBJECT});
			$msg_body .= <<END_OF_MSG;
$result{SUBJECT}
$result{AUTHOR}
$result{DATE}, $result{TIME}
$result{MESSAGE}
----------------------------------------------------------------------
END_OF_MSG

		}
	}
	$msg_body .= "</table>" if uc $IN->{mailtype} eq "HTML";
	
	if (uc $IN->{mailtype} eq "HTML") {
		my $ps_msg = $IN->{message} ? DB->message_check($IN->{message}) : "<P align=\"center\"></P>";
		$msg_body .= qq|
		<BR><table $VARS->{table}>
		<tr bgcolor="black">
			<td><$VARS->{header_font}><b>߽ </b></font>
			</td>
		</tr>
		<tr>
			<td bgcolor="#eeeeee"><blockquote><$VARS->{font}>$ps_msg</font></blockquote>
			</td>
		</tr>
		</table>
		<P>
		<HR SIZE="1">
		<$VARS->{font}>$CONFIG->{copyright}</FONT>
		</body></html>|;
	}
	else { 
		$msg_body .= "߽:\n$IN->{message}\n\n" if $IN->{message};
		$CONFIG->{copyright} =~ s/<BR>/\n/ig;
		$CONFIG->{copyright} =~ s/<P>/\n\n/ig;
		$msg_body .= "======================================================================\n";
		$msg_body .= $CONFIG->{copyright};
	}
	
	require CH::Mailer;
	my $mailer = new CH::Mailer(
			From		=> "$IN->{from_name} <$IN->{from_email}>",
			To		=> $IN->{to},
			Cc		=> $IN->{cc},
			Bcc		=> $IN->{bcc},
			Encoding	=> 'Base64',
			Subject		=> $IN->{subject} ? $IN->{subject} : "$IN->{from_name}    Դϴ.",
			Type		=> uc $IN->{mailtype},
			Data		=> $msg_body
		);

	$mailer->send or $self->error_msg("  ", "CH::Mailer !");
	
	my $html_output = qq|
	<$VARS->{font}>
	<P>б &lt;$IN->{to}&gt;  Ͽϴ.
	<P><A HREF="index.cgi?ch=Forum&do=PostList&cid=$IN->{cid}&b=$IN->{b}">  ưϴ.</A>
	</font>
	|;

	$self->{TEMPLATE}->param( DB->style_vars("б Ϸ ϱ") );
	$self->{TEMPLATE}->param(
				nav_bar 	=> $self->navigation_bar("б  Ϸ!"),
				html_output	=> $html_output
			);

	return $self->{TEMPLATE}->output;
}
