package Plugins::MessageQ;

use strict;
use Setup qw($CONFIG);
use CH::Getform;
use CH::DBUtil;
use vars qw(@ISA);

@ISA = qw(Board);

#----------------------------------------------------------------------
#
#
sub new {
	bless my $self = {};
	
	if ($self->edit_permission($IN->{b})) {
		my $threads = "$CONFIG->{forum_path}/$IN->{b}/$IN->{t}.cgi";
		my $found = 0;
		my ($data_line, $data_rows);
		
		open (FH, $threads);
			flock(FH, 1);
			while (<FH>) {
				chomp;
				if (/^TOPIC/) {
					my @value = DB->data_split($_);
					$value[14] = 0;
					$data_line = join $CONFIG->{db_delim}, @value;
					$data_rows .= $data_line . "\n";
					$found = 1;
				}
				else { $data_rows .= $_ . "\n"; }
			}
		close FH;

		if ($found) {
			DB->_lock($threads);
			open (FH, ">$threads");
				print FH $data_rows;
			close FH;
			DB->_unlock($threads);
		}
	$self->redirect("index.cgi?ch=Forum&do=ReadPost&cid=$IN->{cid}&b=$IN->{b}&t=$IN->{t}");
	
	}
	else { $SESSION->member_login(); }
}
