package Plugins::NewTopic;

use strict;
use Setup qw($CONFIG);
use CH::Getform;
use CH::DBUtil;
use vars qw(@ISA);

@ISA = qw(Board);
	
#----------------------------------------------------------------------
#
#
sub new {
	bless my $self = {};
	
	if ( $self->forum_permission($IN->{b}) ) {
		$self->{TEMPLATE} = DB->load_template("new_post.html");
		$self->{TEMPLATE}->param( DB->style_vars(" ۾") );
		$self->_init(@_);
		$self->{TEMPLATE}->output;
	}
	else { $SESSION->member_login; }
}

#----------------------------------------------------------------------
#
#
sub _init {
	my $self = shift;
	my $name = $MEMBER->login_name;
	my $uid	= $MEMBER->USER_ID;
	my $forum = DB->forum_data($IN->{b});
	my $target = $self->target();
	
	my $hidden_tag = qq|
	<input type="hidden" name="ch" value="Forum">
	<input type="hidden" name="do" value="WritePost">
	<input type="hidden" name="b" value="$IN->{b}">
	<input type="hidden" name="cid" value="$IN->{cid}">
	<input type="hidden" name="target" value="$target">
	|;

	if ($name) { 
		$hidden_tag .= qq|
		<input type="hidden" name="Author" value="$name">
		<input type="hidden" name="UserID" value="$uid">
		|;
	
	} else {
		$name = "<input type=\"text\" onfocus=\"WritePost.Author.value=''\" name=\"Author\" value=\"մ\">";
		$hidden_tag .= '<input type="hidden" name="UserID" value="guest">';
	}
	
	my $html_use = "On"; 
	my $ch_code = "Off";
	
	if ($CONFIG->{use_chcode}) { $html_use = "Off"; $ch_code = "On"; }
	my $use_tag = "HTML ± : $html_use<br>CH ڵ : $ch_code<br>";

	my $content_type = "<FORM ACTION=\"index.cgi\" NAME=\"WritePost\" METHOD=\"POST\">";
	if ($CONFIG->{attach}) {
		$content_type = "<FORM ACTION=\"index.cgi\" NAME=\"WritePost\" METHOD=\"POST\" ENCTYPE=\"multipart/form-data\">";
	}
	my $mailer = ($uid) ? "<BR><INPUT TYPE=CHECKBOX NAME=Mailer VALUE=1 CHECKED> - 亯 ϵǸ 
			  ðڽϱ?" : '';
	
	$self->{TEMPLATE}->param(
			nav_bar		=> $self->navigation_bar(__PACKAGE__, $IN->{cid}, $IN->{b}) . " ۾",
			hidden_tag	=> $hidden_tag,
			author		=> $name,
			forum_name	=> $forum->{Name},
			use_tag		=> $use_tag,
			message_icons	=> DB->message_icon("gif"),
			JSCRIPT		=> DB()->JSEmotion_CHCode(),
			EMOTION_CHCODE	=> DB()->emotion_chcode,
			CONTENT_TYPE	=> $content_type,
			mailer		=> $mailer
		);
}

#----------------------------------------------------------------------
# 			      -- end of source code --
#----------------------------------------------------------------------
