package Plugins::Sendmail;

use strict;
use Setup qw/$CONFIG/;
use CH::Getform;
use CH::DBUtil;
use vars qw/@ISA/;

@ISA = qw/Board/;

sub new {
	bless my $self = {};
	
	if ( $MEMBER->login_name ) {
		$self->{TEMPLATE} = DB->load_template("sendmail.html");
		$self->{TEMPLATE}->param( DB->style_vars("ȸ  ") );
		$self->_init(@_);
		$self->{TEMPLATE}->output;
	}
	else { $SESSION->member_login; }
}

sub _init {
	my $self = shift;
	my $member = $MEMBER->new($IN->{ID});
	my $name = $member->MEMBER_ID();
	my $to = $member->EMAIL();
	my $level = $self->member_level($member->LEVEL());
	
	my $nav = "ȸ  ";
	$self->{TEMPLATE}->param(
				nav_bar 	=> $self->navigation_bar($nav),
				to		=> "$name($level) - $to",
				to_name		=> $name,
				to_email	=> $to,
				from		=> $ENV{REMOTE_ADDR},
			);
}

#----------------------------------------------------------------------
