#!/usr/bin/perl
#===================================================================
#       	    --------------------------
#           	             CHBoard
#		    --------------------------
#
#     : âȣ.
#       : contact@koinweb.co.kr
#   Ȩ: http://www.koinweb.co.kr
#       : chnews.cgi
#
# Copyright (C) 2001 Koinweb - All rights reserved.
#  α׷  Ǿ   ϰų  
# Ǹ  ϴ.
#
#===================================================================

use strict;
use CH::DBUtil;
use Setup qw($CONFIG);
use vars qw(%news);

#----------------------------------------------------------------------
#   .
# 1, 2 ׸ Ȯϰ ԷϿ մϴ.
#----------------------------------------------------------------------

# 1.  index.cgi  ִ URL θ Էմϴ.
$news{ FORUM_URL } = "/cgi-bin/chboard/index.cgi";
	
# 2. ȭ鿡 Ÿ   ID Էմϴ.
$news{ FORUM_ID } = "Forum40";

# 3. ĥ  ϵ  Ÿڽϱ?
$news{ VIEW_TOPIC } = 30;

# 4.  . (1 = Ѵ. 0 = Ѵ.)
$news{ DISPLAY_ICON } = 1;

# 5. ۾ ̸ . (1 = Ѵ. 0 = Ѵ.)
$news{ DISPLAY_AUTHOR } = 0;

# 6.   ð . (1 = Ѵ. 0 = Ѵ.)
$news{ DISPLAY_DATETIME} = 0;

# 7. ̺    (1 = Ѵ. 0 = Ѵ.)
$news{ TOGGLE_COLOR } = 0;

# 8. ½ų   .
$news{ PER_PAGE } = 10;

# 9.   ( date Ǵ author )
$news{ SORT } = "date";

# 10.    
$news{ SUBJECT_LENGTH } = 20;

#----------------------------------------------------------------------
#   .
#----------------------------------------------------------------------

#----------------------------------------------------------------------
# chnews  ƾ. Ư 찡 ƴϸ  ʽÿ.
#----------------------------------------------------------------------
$|++;
&main();

sub main {
	my $fname = [ qw(ID SORT SUBJECT) ];
	my $db_file = "topic.db";
	my $topic = DB->read_data($news{SORT}, $news{FORUM_ID}, $db_file, $news{VIEW_TOPIC}, $fname);
	my $total = scalar @$topic;
	my $end = $news{PER_PAGE};
	my ($html_output, $bgcolor, $cid, $cat);
	
	$cat = DB->get_data($CONFIG->{cat_file});
	LINE: foreach my $i (keys %$cat) {
		foreach (@{$cat->{$i}->{ForumList}}) {
			$news{FORUM_ID} eq $_ and $cid = $i and last LINE;
		}
	}

	$end = $total if $total < $end;
	
	my $more = ""; my $found = 0;
	
	if ($total > $end) {
		$more = qq|<a href="$news{FORUM_URL}?ch=Forum&do=PostList&cid=$cid&b=$news{FORUM_ID}">
			...More News.</a>|;
		$found = 1;
	}

	print "Content-Type: text/html\n\n";
	
	$html_output = qq|<table border="0" cellpadding="0" cellspacing="1" width="100%">|;
	
	foreach my $idx (0..$end-1) {
		my %list_row = %{$topic->[$idx]};
		my $insert_topic_data = DB->insert_data($news{FORUM_ID}, $list_row{ID});
		$bgcolor = $news{TOGGLE_COLOR} ? DB->color($idx) : '';

		while ( my ($key, $val) = each %$insert_topic_data ) {
			$list_row{$key} = $val;
		}

		$list_row{SUBJECT} = DB->trim_text($list_row{SUBJECT}, $news{SUBJECT_LENGTH});
		$html_output .= "<tr $bgcolor><td>";
		$html_output .= $list_row{MSG_ICON} if $news{DISPLAY_ICON};
		$html_output .= qq|<font size="2">
			<a href="$news{FORUM_URL}?ch=Forum&do=ReadPost&cid=$cid&b=$news{FORUM_ID}&t=$list_row{ID}">
			$list_row{SUBJECT}</a></font><br>|;
		$html_output .= "$list_row{DATE}, $list_row{TIME}<br>" if $news{DISPLAY_DATETIME};
		$html_output .= "۾: $list_row{AUTHOR}<br>" if $news{DISPLAY_AUTHOR};
		$html_output .= "</td></tr>";
	}

	if ($found) {
		$html_output .= "<tr><td align=\"right\"><br><font size=\"2\">$more</font></td></tr>\n";
	}
	
	$html_output .= "</table>";
	print $html_output;
}

##  :-)
