#===================================================================
#       	    --------------------------
#           	             CHBoard
#		    --------------------------
#
#     : âȣ.
#       : contact@koinweb.co.kr
#   Ȩ: http://www.koinweb.co.kr
#       : BoardClass.pm
#
# Copyright (C) 2001 Koinweb - All rights reserved.
#  α׷  Ǿ   ϰų  
# Ǹ  ϴ.
#
#===================================================================

package CH::BoardClass;

#----------------------------------------------------------------------
#
use strict;
use Carp qw(confess);
use CH::Getform;
use Setup qw($CONIFG);
use vars qw($AUTOLOAD);

sub new {
	my $this = shift;
	my $class = ref($this) || $this;
	my $self = {};
	
	bless ($self, $class);
	
	return $self;
}

#----------------------------------------------------------------------
#
#
sub html_header {
	my $proto = shift;
	my $header_ref = shift; 
	
	unless ($HTTP_HEADER) {
		my $query = new CGI();
		$query->cache(1);
		
		($header_ref) ? 
		print $query->header(-type=>'text/html', -charset=>'euc-kr', -cookie=>$$header_ref{-cookie}) : 
		print $query->header(-type=>'text/html', -charset=>'euc-kr');
		return $HTTP_HEADER++;
	} 
	else { return 0; }
}

#----------------------------------------------------------------------
#
#
sub get_ip {
	my $proto = shift;
	my $ip;

	if (defined ($ENV{REMOTE_ADDR})) {
		$ip = $ENV{REMOTE_ADDR};
	} else { $ip = 0; }
}

#----------------------------------------------------------------------
#
#
sub script_name {
	my $proto = shift;
	my $script;
	
	if (defined ($ENV{SCRIPT_NAME})) {
		$script = $ENV{SCRIPT_NAME};
	} else { $script = 0; }
}


sub debug {
	my ($self, $level, $msg) = @_;

	return if (! defined $level);
	return if (! defined $msg);

	my $end_of_line = ""; my $head_line = "";

	$head_line = "<font color=\"blue\"><I>";
	$end_of_line = "</I><BR></font>\n";

#	$self->html_header();
#	print "$head_line : $msg$end_of_line";
}

#----------------------------------------------------------------------
#
#
sub AUTOLOAD {
	my $self = shift;
	my $class = ref($self) || confess "$self ü ƴմϴ. ($AUTOLOAD ＼  ϴ.)";
	my $name = $AUTOLOAD;
	
	$name =~ s/.*://;
	
	unless (exists $self->{$name}) {
		confess "$class Ŭ `$name' ׸ ＼  ϴ.";
	}
	
	if (@_) { 
		return $self->{$name} = shift; 
	} else { 
	$self->debug(1, "AUTOLOAD()$self->{$name}");
		return $self->{$name} 
	}
}

#----------------------------------------------------------------------
#
#
sub DESTROY { 
#######################################################################
# 				^_^;
#######################################################################
}


#----------------------------------------------------------------------
1;
