#===================================================================
#       	    --------------------------
#           	             CHBoard
#		    --------------------------
#
#     : âȣ.
#       : contact@koinweb.co.kr
#   Ȩ: http://www.koinweb.co.kr
#       : Member.pm
#
# Copyright (C) 2001 Koinweb - All rights reserved.
#  α׷  Ǿ   ϰų  
# Ǹ  ϴ.
#
#===================================================================

package Member;
#======================================================================

use strict;
use Carp;
use Setup qw($CONFIG $VARS);
use CH::DBUtil;
use CH::Getform;
use vars qw(@ISA);

@ISA = qw(Board);

#----------------------------------------------------------------------
#
#
sub new {
	my $this = shift;
	my $user_id = shift;
	my $class = ref($this) || $this;
	my $self = {};

	$self->{'USER_ID'} 	= undef;	#ȸ ȣ
	$self->{'CREATE_DATE'}  = "";		# ¥
	$self->{'NAME'}		= "";		#Ǹ
	$self->{'EMAIL'}	= "";		#
	$self->{'MEMBER_ID'}	= "";		#ȸ ID
	$self->{'PASSWORD'}	= "";		#йȣ
	$self->{'HOMEPAGE'}	= "";		#Ȩ ּ
	$self->{'BIO'}		= "";		#ڱҰ
	$self->{'JOB'}		= "";		#ϴ
	$self->{'ADDRESS'}	= "";		#°
	$self->{'PHONE'}	= "";		#ó
	$self->{'SIGNATURE'}	= "";		#
	$self->{'PICTURE'}	= "";		#
	$self->{'INTEREST'}	= "";		#
	$self->{'LAST_LOGIN'}	= "0";		#  ð
	$self->{'LEVEL'} 	= 0;		#ȸ 
	$self->{'REFERER'}	= $ENV{HTTP_REFERER};
	$self->{'POST'}		= 0;		#ۼ 
	$self->{'TOPIC_VIEW'}	= 0;		#  . Ư ¥ .
	$self->{'STATUS'} 	= $CONFIG->{member_status};
	$self->{'SESSION_ID'} 	= undef;

	bless $self, $class;

	if (defined($user_id)) {		#α  , ȸ  ´.
		$self->{'USER_ID'} = $user_id;
		$self->_initialize();
	}

	return $self;
}

#----------------------------------------------------------------------
#
#
sub _initialize {
	my $self = shift;
	my $user_id = $self->USER_ID;
	
	if ($user_id) {
		my $list = $self->member_data($user_id);
		
		$self->{'NAME'}		= $list->{'NAME'};
		$self->{'EMAIL'}	= $list->{'EMAIL'};
		$self->{'MEMBER_ID'}	= $list->{'MEMBER_ID'};
		$self->{'PASSWORD'}	= $list->{'PASSWORD'};
		$self->{'HOMEPAGE'}	= $list->{'HOMEPAGE'};
		$self->{'BIO'}		= $list->{'BIO'};
		$self->{'JOB'}		= $list->{'JOB'};
		$self->{'ADDRESS'}	= $list->{'ADDRESS'};
		$self->{'PHONE'}	= $list->{'PHONE'};
		$self->{'PICTURE'}	= $list->{'PICTURE'};
		$self->{'INTEREST'}	= $list->{'INTEREST'};
		$self->{'SIGNATURE'}	= $list->{'SIGNATURE'};
		$self->{'LEVEL'}	= $list->{'MEMBER_LEVEL'};
		$self->{'POST'}		= $list->{'POST'};
		$self->{'TOPIC_VIEW'}	= $list->{'TOPIC_VIEW'};
		$self->{'STATUS'}	= $list->{'STATUS'};
		$self->{'SESSION_ID'}	= $list->{'SESSION_ID'};
	}
}

#----------------------------------------------------------------------
# ƾ: 	login_name()
# : 	ȸ α ID ´. 
# ϰ: 	ȸ ID Ǵ Ǹ.
#----------------------------------------------------------------------
sub login_name {
	return $_[0]->{MEMBER_ID} || $_[0]->{NAME};
}

#----------------------------------------------------------------------
# ƾ: 	register_form()
# : 	űȸ   .
# ϰ: 	register_form.html  .
#----------------------------------------------------------------------
sub register_form {
	my $self = shift;
	my $html_output = "";
	
	unless ($CONFIG->{auth_allow_registration}) {
		$self->error_msg(" ź", " ڰ ű ȸ  ް  ʽϴ.");
	}
	
	$self->{'TEMPLATE'} = DB->load_template("register_form.html");
	$self->{'TEMPLATE'}->param( DB->style_vars("űȸ ") );
	
	if ($CONFIG->{register_via_email}) {
		$html_output = qq~
		<tr $VARS->{forum_bgcolor}>
			<td width="50%"><$VARS->{font}><b>ȸ ID:</b> ( ĺ ڸ )</font>
			</td>
			<td valign="top" width="50%"><input type="text" name="memberid"></td>
		</tr>
		<tr $VARS->{forum_bgcolor}>
			<td><$VARS->{font}><b>Email:</b></font>
			</td>
			<td valign="top"><input type="text" name="email"></td>
		</tr>
		<tr $VARS->{forum_bgcolor}>
			<td><$VARS->{font}><b≯(Ǹ):</b> (Ư   )</font>
			</td>
			<td valign="top"><input type="text" name="name">
			</td>
		</tr>~;
	}
	else {
		$html_output = qq~
		<tr $VARS->{forum_bgcolor}>
			<td width="50%"><$VARS->{font}><b>ȸ ID:</b> ( ĺ ڸ )</font>
			</td>
			<td valign="top" width="50%"><input type="text" name="memberid"></td>
		</tr>
		<tr $VARS->{forum_bgcolor}>
			<td><$VARS->{font}><b>йȣ:</b></font>
			</td>
			<td valign="top"><input type="password" name="password"></td>
		</tr>
		<tr $VARS->{forum_bgcolor}>
			<td><$VARS->{font}><b>йȣ Ȯ:</b></font>
			</td>
			<td><input type="password" name="password2"></td>
		</tr>
		<tr $VARS->{forum_bgcolor}>
			<td><$VARS->{font}><b>Email:</b></font>
			</td>
			<td valign="top"><input type="text" name="email"></td>
		</tr>
		<tr $VARS->{forum_bgcolor}>
			<td><$VARS->{font}><b≯(Ǹ):</b> (Ư   )</font>
			</td>
			<td valign="top"><input type="text" name="name">
			</td>
		</tr>~;
	}

	$self->{'TEMPLATE'}->param( 
				name 		=> $self->{NAME},
				html_output	=> $html_output,
				topic_view	=> $self->topic_view(7),
				nav_bar		=> $self->navigation_bar("ȸ")
			);
	return $self->{'TEMPLATE'}->output;
}

#----------------------------------------------------------------------
# ƾ: 	topic_view()
# : 	ƯⰣ  ϵ ۸ .
# ϰ: 	$topic_view
#----------------------------------------------------------------------
sub topic_view {
	my ($self, $topic) = @_;
	my @view_array = qw(1 3 7 15 30 60 90 180 365 1095);

	my $topic_view = qq|
	<table border="0" cellpadding="0" cellspacing="0">
	<tr><td>
	<select name="topic_view">|;
	
	my $msg = "  ϵ ۸ ";

	foreach (@view_array) {
		$topic_view .= "<option value=\"$_\"";
		$topic_view .= " selected" if $_ == $topic;
		$topic_view .= ">$_$msg\n";
	}
	
	$topic_view =~ s/1$msg/ ϵ ۸ /g;
	$topic_view =~ s/1095$msg/  /g;
	$topic_view .= "</select></td></tr></table>";
	
	return $topic_view;
}

#----------------------------------------------------------------------
# ƾ: 	edit_profile()
# : 	ȸ .
# ϰ: 	edit_profile.html  .
#----------------------------------------------------------------------
sub edit_profile {
	my $self = shift;
	my $uid = $MEMBER->USER_ID;
	
	if ($uid) {
		my $member = $self->member_data($uid);

		if ($IN->{action} eq "save") {
			my $check = FormCheck->new;
			$check->verify_multi(
				[
					{ 
						-name		=> 'email',
						-msg_name	=> 'E-Mail',
						-value		=> $IN->{email},
						-type		=> 'email'
					},
				],
			);

			if ($check->errors) {
				my $err_msg = shift;
				$self->error_msg(" ׸񿡼  ߻Ͽϴ.", $check->errors);
				exit 0;
			}
	
			if ($IN->{password} ne $IN->{password2}) {
				$self->error_msg(" ߻Ͽϴ.", "йȣ ġ ʽϴ.");
				exit 0;
			}
		
			my $password = $IN->{password} ? DB->encrypt($IN->{password}) : $member->{PASSWORD};
		
			$member->{ PASSWORD } 	= $password;
			$member->{ EMAIL }	= $self->escape_input(lc $IN->{email});
			$member->{ HOMEPAGE }	= $self->escape_input(lc $IN->{homepage});
			$member->{ PICTURE }	= $self->escape_input($IN->{picture});
			$member->{ NAME	}	= $self->escape_input($IN->{name});
			$member->{ SIGNATURE }	= DB->message_check($IN->{signature});
			$member->{ PHONE }	= $self->escape_input($IN->{phone});
			$member->{ ADDRESS }	= $self->escape_input($IN->{address});
			$member->{ JOB }	= $self->escape_input($IN->{job});
			$member->{ BIO }	= DB->message_check($IN->{bio});
			$member->{ INTEREST }	= $self->escape_input($IN->{interest});
			$member->{ TOPIC_VIEW }	= $IN->{topic_view};
			
			DB->_dumper("$CONFIG->{member_directory}/$uid.cgi", $member);
			
			$member->{PICTURE} = "<img src=\"$member->{PICTURE}\">" if $member->{PICTURE};
			$member->{EMAIL} = "<a href=\"mailto:$member->{EMAIL}\">$member->{EMAIL}</a>";
			$member->{HOMEPAGE} = "<a href=\"$member->{HOMEPAGE}\" target=\"_blank\">$member->{HOMEPAGE}</a>";
			my $msg = '  ϵ ۸ ';
			my $topic_view = $member->{TOPIC_VIEW} . $msg;
			
			$topic_view =~ s/1$msg/ ϵ ۸ /g;
			$topic_view =~ s/1095$msg/  /g;
			
			$self->{TEMPLATE} = DB->load_template("edit_profile_success.html");
			$self->{TEMPLATE}->param( DB->style_vars("ȸ  Ϸ!") );
			$self->{TEMPLATE}->param( 
				nav_bar 	=> $self->navigation_bar("ȸ  Ϸ!"),
				topic_view_msg 	=> $topic_view
				);
			
			while ( my ($key, $value) = each %$member ) {
				$value = 'Է ' unless $value;
				$self->{TEMPLATE}->param($key, $value); 
			}
		}
		else {
		
			$self->{TEMPLATE} = DB->load_template("edit_profile.html");
			foreach (keys %$member) {
				$member->{BIO} = DB->msg_to_form($member->{BIO});
				$member->{SIGNATURE} = DB->msg_to_form($member->{SIGNATURE});
				$self->{TEMPLATE}->param($_, $member->{$_}); 
			}
			
			$self->{TEMPLATE}->param( DB->style_vars("ȸ ") );
			$self->{TEMPLATE}->param( 
					nav_bar 	=> $self->navigation_bar("ȸ "),
					topic_view	=> $self->topic_view($member->{TOPIC_VIEW}) );
		}
		return $self->{TEMPLATE}->output;
	}
	else { $SESSION->member_login(); }
}

#----------------------------------------------------------------------
# ƾ: 	member_profile()
# : 	ȸ .
# ϰ: 	member_profile.html  .
#		йȣ   ȸ .
#----------------------------------------------------------------------
sub member_profile {
	my $member = DB->get_data("$CONFIG->{member_directory}/$IN->{'ID'}.cgi");
	
	delete $member->{PASSWORD};

	$member->{MEMBER_LEVEL} = $_[0]->member_level($member->{MEMBER_LEVEL});
	$member->{EMAIL} = "<A HREF=\"index.cgi?ch=Forum&do=Sendmail&ID=$IN->{ID}\">$member->{EMAIL}</A>";
	$member->{HOMEPAGE} = "<A HREF=\"$member->{HOMEPAGE}\" TARGET=\"_BLANK\">$member->{HOMEPAGE}</A>"
		if $member->{HOMEPAGE};

	$member->{POST} = $member->{POST} ? 
		($member->{POST} . " " .
		" (<a href=index.cgi?ch=Forum&do=Search&forum=all&field=name&date=all&query=$member->{MEMBER_ID}>" .
		" </a>)") :
		"";

	my $tpl = DB->load_template("member_profile.html");
	$tpl->param( DB->style_vars("ȸ ") );
	$tpl->param( nav_bar => $_[0]->navigation_bar("ȸ ") );
	
	while ( my ($key, $value) = each %$member ) {
		$value = 'Է ' unless $value;
		$tpl->param($key, $value); 
	}

	return $tpl->output;
}

sub members_list {
	my $self = shift;
	my ($link, $count, @result, @letter, @type);
	my $list = DB->get_data($CONFIG->{users});
	
	@letter = ('1-9', 'A'..'Z', 'ALL');

	my $letter_table = qq|
	$VARS->{table_top}
	<table $VARS->{table}>
	<tr $VARS->{msgbox_color}>|;
	
	my $letter_table_width = int(100 / scalar @letter);

	foreach (@letter) {
		if ($IN->{sort} eq $_) {
			$link = $_; 
		} else { 
			$link = "<a href=\"index.cgi?ch=Member&do=members_list&sort=$_\">$_</a>";
		}
		$letter_table .= "\n<th width=\"$letter_table_width%\" nowrap>" . 
				"<font size=\"1\" face=\"verdana\">$link</font>\n</th>";
	}
	
	$letter_table .= "</tr></table>$VARS->{table_bottom}";
	
	my $term = $IN->{sort};
	$term = '\d' if $IN->{sort} eq "1-9";
	$term = '*' if $term eq 'ALL';
	
	my $total = 0;
	for (sort {$list->{$a} cmp $list->{$b}} keys %$list) {
		uc($list->{$_}) =~ /^$term/ and push @result, $self->member_data($_);
		$total++;
	}
	
	my $html_output = qq|
	<BR>
	<table $VARS->{s_table}>
	<tr>
		<td>
		<$VARS->{font}> ȸ: <b>$total</b>  ( Ȱ  ȸ Ͽ Ÿ ʽϴ.)
		<br><li>  </font>
	$VARS->{table_bottom}
	<BR>

	$letter_table
	
	<P>
	$VARS->{table_top}
	<table $VARS->{table}>
	<tr $VARS->{bg_header}>
		<th>
			<$VARS->{header_font}>ȸ ID</font>
		</th><th>
			<$VARS->{header_font}>ȸ з</font>
		</th><th>
			<$VARS->{header_font}>ۼ</font>
		</th><th>
			<$VARS->{header_font}>Ȩ</font>
		</th><th>
			<$VARS->{header_font}>E-Mail</font>
		</th><th>
			<$VARS->{header_font}></font>
		</th>
	</tr>|;
	
	$IN->{page} = 1 unless $IN->{page};
	
	my $total = scalar @result;
	my $start = (($IN->{page} - 1) * $CONFIG->{per_page}) + 1;
	my $end = $IN->{page} * $CONFIG->{per_page};
	$end = $total if $total < $end;
	
	my $page = DB->span_page($start, $end, $total, $CONFIG->{per_page}, $IN);
	
	unless (@result) {
		$html_output .= qq|
		<tr $VARS->{forum_bgcolor}>
		<th colspan="7">
		<BR>
			<$VARS->{font}> ȸ ϴ.</font>
		<P>
		</th></tr>|;
	}
	else {
		my $count = 0;
		for my $idx ($start-1 .. $end-1) {
			
			next unless $result[$idx]{STATUS};

			my $level = $self->member_level($result[$idx]{MEMBER_LEVEL});
			my $homepage = '';
			
			if (-e "$CONFIG->{member_directory}/online/$result[$idx]{USER_ID}") {
				$result[$idx]{MEMBER_ID} = "<li>$result[$idx]{MEMBER_ID}";
			}
		
			my $uid = "<a href=\"index.cgi?ch=Member&do=member_profile&ID=$result[$idx]{USER_ID}\">" .
				"$result[$idx]{MEMBER_ID}</a>";
		
			if ($result[$idx]{HOMEPAGE}) { 
				$homepage = "<a href=\"$result[$idx]{HOMEPAGE}\" target=\"_blank\">" .
					"$result[$idx]{HOMEPAGE}</a>";
			}

			my $number = $idx + 1;
			my $email = "<a href=\"mailto:$result[$idx]{EMAIL}\">$result[$idx]{EMAIL}</a>";
			my $bgcolor = DB->color($count);
	
			$html_output .= qq|
			<tr $bgcolor>
				<td align="center">
					<$VARS->{font}>$uid</font>
				</td><td align="center">
					<$VARS->{font}>$level</font>
				</td><td align="center">
					<$VARS->{font}>$result[$idx]{POST}</font>
				</td><td align="center">
					<$VARS->{font}>$homepage</font>
				</td><td align="center">
					<$VARS->{font}>$email</font>
				</td><td align="center">
					<$VARS->{font}>$result[$idx]{CREATE_DATE}</font>
				</td>
			</tr>|;
			$count++
			}
		
		$html_output .= qq|<tr $VARS->{forum_bgcolor}>
			<td colspan="7" align="center">
			<$VARS->{font}>$page</font>
			</td>
		</tr>| if $page;
	}

	$html_output .= "</table>$VARS->{table_bottom}<P>";

	my $tpl = DB->load_template("member_list.html");
	$tpl->param( DB->style_vars("ȸ ") );
	$tpl->param( 
			nav_bar		=> $self->navigation_bar("ȸ "),
			html_output	=> $html_output
		);
	return $tpl->output;
}
		
#----------------------------------------------------------------------
# ƾ: 	escape_input() 
# : 	Է ڸ ˻Ͽ   ġ.
# ϰ: 	$s(Է¹ ڿ)
#----------------------------------------------------------------------
sub escape_input {
	my $self = shift;
	my $s = shift;
	
	$s =~ s,^\s+,,g;
	$s =~ s,\s+$,,g;
	$s =~ s,&,&amp;,gso;
	$s =~ s,<,&lt;,gso;
	$s =~ s,>,&gt;,gso;
	$s =~ s,\",&quot;,gso;
	$s =~ s,\|,&#0124;,gso;
	$s =~ s/\s{2,}/ /g;

	return $s;
}

#----------------------------------------------------------------------
#
#
sub _escape {
	my $self = shift;
	my $s = shift;
	$s =~ s/([^a-zA-Z0-9_.-])/uc sprintf("%%%02x", ord($1))/ge;
	return $s;
}

#----------------------------------------------------------------------
#
#
sub register {
	my $self = shift;

	# ʼ Է ׸ ٸ Էߴ ȮѴ.
	my $check = FormCheck->new;
	$check->verify_multi(
			[
				{ 
					-name		=> 'email',
					-msg_name	=> 'Email',
					-value		=> $IN->{email},
					-type		=> 'email'
				},
				{
					-name		=> 'memberid',
					-msg_name	=> 'ȸ ID ߺ Ǵ  IDԴϴ.',
					-value		=> $IN->{memberid},
					-type		=> 'memberid'
				},
				
				{
					-name		=> 'name',
					-msg_name	=> 'Ǹ ùٸ ʽϴ.',
					-value		=> $IN->{name},
					-type		=> 'name'
				},
			]
		);

	#Է ׸   ,  ޽ ϰ .
	unless ($IN->{memberid}) {
		$self->error_msg(" ߻Ͽϴ.", "ȸID Է ̽ϴ.");
		exit 0;
	}
	
	my ($html_output, $password);
	

	if ($CONFIG->{register_via_email}) {
		my ($tmp, $a, $rnd_passwd, $random, $one, $two, $salt, $crypt);
		my @random_array = ('a'..'z', '1'..'9');
		
		$a = time();
		srand($a);

		for ( my $idx = 0; $idx < 6; $idx++ ) {
			$random = int(rand($#random_array + 1));
			$tmp .= $random_array[$random];
		}

		$one = int(rand($#random_array)) + 1;
		$two = int(rand($#random_array)) + 1;
		$salt = "$random_array[$one]" . "$random_array[$two]";
		$crypt = crypt($tmp, $salt);
		
		$password = DB->encrypt($crypt);
		
		my $message = qq~
   Դϴ.
=====================================================
ȸ ID: $IN->{memberid}
йȣ: $crypt
̸: $IN->{name}

 Ͻ     йȣ Ͽ ֽʽÿ.
  ְų ǻ   ڿ Ͽ ֽʽÿ.
 Ͽ ּż մϴ.

-----------------------------------------------------
  - $CONFIG->{admin_email}
$CONFIG->{site_url}
~;
		require CH::Mailer;
		my $mailer = new CH::Mailer (
				From		=> "$CONFIG->{title} <$CONFIG->{admin_email}>",
				To		=> $IN->{email},
				Subject		=> "  ",
				Encoding	=> 'Base64',
				Data		=> $message
			);
		$mailer->send or die "CH::Mailer !";
		$html_output = " йȣ $IN->{email} Ƚϴ.<P>
		 <a href=\"index.cgi?ch=Login&do=member\">α</a> Ͽ ֽʽÿ.";
	}
	else {
		$check->verify_multi(
				[ {
					-name		=> 'password',
					-msg_name	=> 'йȣ',
					-value		=> $IN->{password},
					-type		=> 'password'
				} ]
			);
		if ($IN->{password} ne $IN->{password2}) {
			$self->error_msg(" ߻Ͽϴ.", "йȣ ġ ʽϴ.");
			exit 0;
		}
	$password = DB->encrypt($IN->{password});
	$html_output = " <a href=\"index.cgi?ch=Login&do=member\">α</a> Ͽ ֽʽÿ.";
	}
	
	if ($check->errors) {
		my $err_msg = shift;
		$self->error_msg(" ׸񿡼  ߻Ͽϴ.", $check->errors);
		exit 0;
	}
	
	my $member = Member->new();	# Member Ŭ ʱȭ.
	my $session_id = DB->encrypt( time . $$ . int(rand(16000)));
	$session_id = substr($session_id, 0, 20);

	$member->EMAIL		( $self->escape_input(lc $IN->{email}) );
	$member->PASSWORD	( $password );
	$member->HOMEPAGE	( $self->escape_input($IN->{homepage}) );
	$member->NAME		( $self->escape_input($IN->{name}) );
	$member->SIGNATURE	( $self->escape_input($IN->{signature}) );
	$member->PHONE		( $self->escape_input($IN->{phone}) );
	$member->ADDRESS	( $self->escape_input($IN->{address}) );
	$member->JOB		( $self->escape_input($IN->{job}) );
	$member->BIO		( $self->escape_input($IN->{bio}) );
	$member->INTEREST	( $self->escape_input($IN->{interest}) );
	$member->PICTURE	( $self->escape_input($IN->{picture}) );
	$member->MEMBER_ID	( $self->escape_input($IN->{memberid}) );
	$member->LEVEL		( $CONFIG->{default_level} );
	$member->TOPIC_VIEW	( $IN->{topic_view} );
	$member->SESSION_ID	( $session_id);

	my $user_id = $member->add_member();	#Է  Ͽ Ѵ.
	
	$SESSION = Login->new(); 		#α  ʱȭ.
	$MEMBER = Member->new($user_id);	#ȸ  ´.
	
	if ($CONFIG->{auth_notify_admin_on_registration}) {
		my $subject = 'ű ȸ Ͽϴ.';
		my $msg = <<END_OF_MSG;
$subject
----------------------------------------------------------------------
ű ȸ   ϴ.

ȸ ̸: $MEMBER->{MEMBER_ID}
ȸ ID: $MEMBER->{MEMBER_ID}
E-mail: $MEMBER->{EMAIL}
IP: $MEMBER->{IP}

END_OF_MSG
		
		require CH::Mailer;
		my $mailer = new CH::Mailer (
			From		=> " ȸ  <$CONFIG->{admin_email}>",
			To		=> "  <$CONFIG->{admin_email}>",
			Encoding	=> 'Base64',
			Subject		=> $subject,
			Data		=> $msg,
			Type		=> 'TEXT'
			) or $self->error_msg("  ", "CH::Mailer !");
		
		$mailer->send() or $self->error_msg("  ", "CH::Mailer !");
	}

	
	$self->{TEMPLATE} = DB->load_template("register_success.html");
	$self->{TEMPLATE}->param( DB->style_vars("ȸ ԵǾϴ.") );
	$self->{TEMPLATE}->param( 
			html_output 	=> $html_output,
			member		=> $IN->{name} );
	
	$self->{TEMPLATE}->output;
}

#----------------------------------------------------------------------
#
#
sub add_member {
	my $self = shift;
	my $user_id = 1;
	
	my %member = (
		USER_ID		=> $user_id,
		CREATE_DATE	=> DB->current_date(),
		NAME		=> $self->{'NAME'},
		EMAIL		=> $self->{'EMAIL'},
		MEMBER_ID	=> $self->{'MEMBER_ID'},
		PASSWORD	=> $self->{'PASSWORD'},
		HOMEPAGE	=> $self->{'HOMEPAGE'},
		ADDRESS		=> $self->{'ADDRESS'},
		BIO		=> $self->{'BIO'},
		JOB		=> $self->{'JOB'},
		PHONE		=> $self->{'PHONE'},
		SIGNATURE	=> $self->{'SIGNATURE'},
		LAST_LOGIN	=> DB->current_date(),
		MEMBER_LEVEL	=> $self->{'LEVEL'},
		PICTURE		=> $self->{'PICTURE'},
		INTEREST	=> $self->{'INTEREST'},
		POST		=> $self->{'POST'},
		TOPIC_VIEW	=> $self->{'TOPIC_VIEW'},
		STATUS		=> $self->{'STATUS'},
		IP 		=> $ENV{'REMOTE_ADDR'},
		SESSION_ID	=> $self->{'SESSION_ID'}
	);
	
	my $id_file = "$CONFIG->{data_directory}/Members/member_id.txt";
	my $db_file = $CONFIG->{users};
	
	
	if (-e $id_file) {
		open (ID, $id_file);
			$user_id = <ID> + 1;
		close ID;
		open (ID, ">$id_file");
			print ID $user_id;
		close ID;
	}
	else {
		open (ID, ">$id_file");
			print ID 1;
		close ID;	
		chmod 0666, $id_file;
	}

	$member{USER_ID} = $user_id;
	
	if ($user_id == 1){
		$member{MEMBER_LEVEL} = 9;
		my $c = DB->get_data("$CONFIG->{data_directory}/chboard.cfg");
		$c->{contact_email} = $c->{admin_email} = $member{EMAIL};
		$member{ TOPIC_VIEW } = 15;
		DB->_dumper("$CONFIG->{data_directory}/chboard.cfg", $c);
	}
	
	DB->_dumper("$CONFIG->{member_directory}/$user_id.cgi", \%member);

	my $member_list = DB->get_data($db_file);
	$member_list->{$user_id} = $self->{MEMBER_ID};
	
	DB->_dumper($db_file, $member_list);

	#----------------------------------------------------------------------
	#    .
	#----------------------------------------------------------------------

	open (FH, ">$CONFIG->{member_directory}/total.txt") or die "error: $!\n";
		flock(FH, 2);
		print FH scalar @{ [ keys %$member_list ]};
	close FH;
	chmod 0666, "$CONFIG->{member_directory}/total.txt";
	
	#----------------------------------------------------------------------
	# ű ȸ ID .
	#----------------------------------------------------------------------
	
	open (FH, ">$CONFIG->{member_directory}/new_member.txt") or die "error: $!\n";
		flock(FH, 2);
		print FH $user_id;
	close FH;
	chmod 0666, "$CONFIG->{member_directory}/new_member.txt";
	
	$self->USER_ID($user_id);
	return $user_id;
}

#----------------------------------------------------------------------
#
#
sub DESTROY { shift; }

#===================================================================
#       	    --------------------------
#           	             CHBoard
#		    --------------------------
#
#     : âȣ.
#       : contact@koinweb.co.kr
#   Ȩ: http://www.koinweb.co.kr
#       : Login.pm
#
# Copyright (C) 2001 Koinweb - All rights reserved.
#  α׷  Ǿ   ϰų  
# Ǹ  ϴ.
#
#===================================================================

package Login;
#======================================================================

use strict;
use Carp;
use CH::Getform;
use CH::MD5;
use CH::DBUtil;
use Setup qw/$CONFIG/;
use vars qw/@ISA/;

@ISA = qw/Board/;

#----------------------------------------------------------------------
#
#
sub new {
	my $this = shift;
	my $user_id = shift;
	my $class = ref($this) || $this;
	my $self = {};

	$self->{USER_ID}	= "";
	$self->{IP}		= "";
	$self->{LAST_LOGIN}	= "";
	$self->{REFERER}	= $ENV{HTTP_REFERER};
	$self->{SESSION}	= undef;
	
	bless $self, $class;

	if ($user_id) { $self->_initialize($user_id) }

	return $self;
}

#----------------------------------------------------------------------
#
#
sub _initialize {
	my $self = shift;
	my $user_id = shift;

	my $list = DB->get_data($CONFIG->{users});
	
	if (exists $list->{$user_id}) {
		$self->{USER_ID} = $user_id;
		$self->{IP} = $ENV{'REMOTE_ADDR'};
		$self->{SESSION} = $MEMBER->SESSION_ID();
	} 
	else { 
		$self->{USER_ID} = "";
		$self->{IP} = 'NO IP ADDRESS';
	}
	return "OK";
}

#----------------------------------------------------------------------
#
#
sub clear {
	my $self = shift;
	my $s = shift;
	my $ip = shift || 'NO IP ADDRESS';
	my $uid = $self->{USER_ID};
	my $file = "$CONFIG->{member_directory}/$uid.cgi";
	my $member = DB->get_data($file);
	
	$member->{IP} = $ip;
	$member->{LAST_LOGIN} = $s;
	
	DB->_dumper($file, $member);
}

#----------------------------------------------------------------------
#
#
sub member_exists {
	my ($self, $member_id) = @_;
	my $list = DB->get_data($CONFIG->{users});

	foreach (keys %{$list}) {
		$list->{$_} eq "$member_id" and return $_;
	}
	return 0;
}

#----------------------------------------------------------------------
#
#
sub member {
	my $self = shift;
	my $err_msg = shift;
	my $location = $self->REFERER;
	
	$location = ($location =~ /register_form|Login/) ? 'index.cgi' : $location;
	
	$self->{TEMPLATE} = DB()->load_template("login.html");
	$self->{TEMPLATE}->param( DB->style_vars("ȸ α") );
	$self->{TEMPLATE}->param( 
				location	=> $location,
				nav_bar 	=> $self->navigation_bar("α")
			);
	
	if ($err_msg) { $self->{TEMPLATE}->param( error=> $err_msg ); }
	
	return $self->{TEMPLATE}->output;
}

#----------------------------------------------------------------------
#
#
sub member_login {
	my $self = shift;
	my $err_msg = shift;
	
	$self->{TEMPLATE} = DB->load_template("login.html");
	$self->{TEMPLATE}->param( DB->style_vars("ȸ α") );
	$self->{TEMPLATE}->param( 
				location	=> $self->redirect_login,
				nav_bar 	=> $self->navigation_bar("α")
			);
	
	if ($err_msg) { 
		$self->{TEMPLATE}->param( error=> $err_msg );
	}
	
	return $self->{TEMPLATE}->output;
}

#----------------------------------------------------------------------
#
#
sub member_check {
	my $self = shift;
	my $member = $IN->{member_id};
	my $member_id = $self->member_exists($member);
	my $location = ($IN->{location} !~ /logout/) ? $IN->{location} : 'index.cgi';
	my $user = $self->member_data($member_id) || '';
	
	$self->html_header();
	
	if (!$member_id) {
		print $self->member("ȸ ID Ȯ ʽϴ."); 
		exit 0;
	}
	
	if (!$IN->{password}) {
		print $self->member("йȣ Էϴ  ̱?");
		exit 0;
	}
	
	if (! $self->USER_ID) {
		print $self->member("йȣ  ʽϴ.");
		exit 0;
	}
	
	unless ($user->{STATUS}) {
		print $self->member("   Ȱ Դϴ.");
		exit 0;
	}	
	
	print "<META HTTP-EQUIV='Refresh' CONTENT='0; URL=$location'>";
	exit(0);
}

#----------------------------------------------------------------------
#
#
sub logout{
	require "Plugins/Home.pm";
	$MEMBER = Member->new(-1);
	Plugins::Home->new(0);
}

#===================================================================
#       	    --------------------------
#           	             CHBoard
#		    --------------------------
#
#     : âȣ.
#       : contact@koinweb.co.kr
#   Ȩ: http://www.koinweb.co.kr
#       : FormCheck.pm
#
# Copyright (C) 2001 Koinweb - All rights reserved.
#  α׷  Ǿ   ϰų  
# Ǹ  ϴ.
#
#===================================================================

package FormCheck;
#===================================================================

use strict;
use Setup qw/$CONFIG/;
use CH::DBUtil;
use vars qw/@ISA/;
@ISA = qw/Board/;

sub new {
	my $this = shift;
	my $class = ref($this)||$this;
	my $self = {};
	bless $self, $class;

	my @array = ();
	$self->{ERRORS} = \@array;

	return $self;
}

#----------------------------------------------------------------------
#
#
sub verify_multi {
	my $self = shift;
	my $params = shift;

	foreach my $param(@$params) {
		$self->verify(
				$param->{'-type'},
				$param->{'-msg_name'},
				$param->{'-value'},
				$param->{'-name'}
			);
	}
}

#----------------------------------------------------------------------
#
#
sub verify {
	my $self = shift;
	my ($type, $name, $value, $format) = @_;
	my $result = undef;

	if ($type eq 'email') {
		$result = $self->email($value);
	}
	elsif ($type eq 'homepage') {
		$result = ($value) ? $self->url($value) : 1;
	}
	elsif ($type eq 'memberid') {
		$result = $self->memberid_check($value);
	}
	elsif($type eq 'name') {
		$result = $self->name($value);
	}
	else { 
		$result = $self->empty_check($value);
	}

	unless ($result) {
		$self->add_error($name);
	}
}

#----------------------------------------------------------------------
#
#
sub add_error {
	my $self = shift;
	my $name = shift;
	my $err_ref = $self->{'ERRORS'};
	my @errors = @$err_ref;

	push @errors, $name;
	$self->{'ERRORS'} = \@errors;
}

#----------------------------------------------------------------------
#
#
sub errors {
	my $self = shift;
	my $error_ref = $self->{'ERRORS'};
	my @errors = @$error_ref;
	my $output = "";
	
	if (scalar(@errors) > 0) { 
		foreach (@errors) {
			$output .= "<LI>$_"; 
		}
		return $output;
	}
	return undef;
}

#----------------------------------------------------------------------
# ȸ Ͻ  ȸ ID ߺ ʴ  ȮѴ.
#
sub memberid_check {
	my ($self, $value) = @_;
	my $list = DB->get_data("$CONFIG->{member_directory}/member_list.db");

	foreach (values %$list) {
		return 0 if $_ eq $value;	# ߺǸ 0 .
	}
	return ($value =~ m/\W/) ? 0 : 1;
}

#----------------------------------------------------------------------
# ּҸ Ȯϰ Էߴ ˻Ѵ.
#
sub email {
	my $self = shift;
	my $value = shift;
	return ($value =~ m,.?@.*\.,) ? 1 : 0;
}

#----------------------------------------------------------------------
# URL ּ  ùٸ ȮѴ.
#
sub url {
	my ($self, $value) = @_;
	return ($value =~ m,http://\w,) ? 1 : 0;
}

sub name {
	my ($self, $name) = @_;
	
	my $bad_chrs = quotemeta ("!`~@#$%^&*-_=+()[]{};:'><,./?\|");
	return ($name !~ m,[\"$bad_chrs]+,) ? 1 : 0;
}

#----------------------------------------------------------------------
# Էؾ  ׸ Է ʾ 츦 ȮѴ.
# 
sub empty_check {
	my ($self, $value) = @_;
	return ($value) ? 1 : 0;
}
#----------------------------------------------------------------------
#
1;
