package Plugins::NewReply;

#----------------------------------------------------------------------
# ʿ  Ѵ.
use strict;
use Setup qw/$CONFIG/;
use CH::Getform;
use CH::DBUtil;
use vars qw/@ISA/;

@ISA = qw/Board/; # Board Ŭ Ѵ.

#----------------------------------------------------------------------
#
#
sub new {
	my $self = bless {};
	
	if ($IN->{c} and !$self->edit_permission($IN->{b})) {
		$self->error_msg("   ϴ!", " б ڰ Ͽϴ.");
	}
	else { 
		$self->{TEMPLATE} = DB()->load_template("new_reply.html");
		$self->{TEMPLATE}->param( DB()->style_vars("亯 ") );
		$self->_init(@_);
		return $self->{TEMPLATE}->output;
	}
}

#----------------------------------------------------------------------
#
#
sub _init {
	my $self = shift;
	my $forum_info = DB->get_data("$CONFIG->{forum_path}/$IN->{b}.info");
	my $name = $MEMBER->login_name(); #ȸ ID ´. 
	my $target = DB()->target;
	my @data_line = ();
	
	open (FH, "<$CONFIG->{forum_path}/$IN->{b}/$IN->{t}.cgi");
		flock (FH, 1);
		LINE: while (<FH>) {
			/^REPLY.$IN->{omm}/ and @data_line = DB->data_split($_) and last LINE;
		}
	close FH;
	
	#----------------------------------------------------------------------
	#  ± .
	#----------------------------------------------------------------------
	
	my $hidden_tag = qq|
	<input type="hidden" name="ch" value="Forum">
	<input type="hidden" name="do" value="WriteReply">
	<input type="hidden" name="b" value="$IN->{b}">
	<input type="hidden" name="cid" value="$IN->{cid}">
	<input type="hidden" name="t" value="$IN->{t}">
	<input type="hidden" name="omm" value="$IN->{omm}">
	<input type="hidden" name="target" value="$target">|;

	if ($name) { 				#α ȸ .
		my $uid = $MEMBER->USER_ID();
		$hidden_tag .= qq|
		<input type="hidden" name="Author" value="$name">
		<input type="hidden" name="UserID" value="$uid">|;
	
	} else { 				#ȸ .
		$name = "<input type=\"text\" onfocus=\"WritePost.Author.value=''\" name=\"Author\" value=\"մ\">";
		$hidden_tag .= '<input type="hidden" name="UserID" value="guest">';
	}
	
	my $html_use = "On"; 
	my $ch_code = "Off";
	
	if ($CONFIG->{use_chcode}) { $html_use = "Off"; $ch_code = "On"; }
	
	my $use_tag = "HTML ± : $html_use<br>CH ڵ : $ch_code<br>";
	my $topic_url = "index.cgi?ch=Forum&do=ReadPost&b=$IN->{b}&t=$IN->{t}&omm=$IN->{omm}";
	
	#----------------------------------------------------------------------
	#øƮ  ش  .
	#----------------------------------------------------------------------

	$self->{TEMPLATE}->param( 
		SUBJECT 	=> sub {
					my $subject = $data_line[2];
					$subject = "亯: " . $subject unless($subject =~ /^亯:/);
					return $subject;
				},
		QUOTE		=> my $quote = ($IN->{what}) ? 1 : 0,
		OLD_SUBJECT	=> $data_line[2], 		# .
		MESSAGE		=> DB->msg_to_form($data_line[3]),
		Q_MESSAGE	=> $data_line[3], 		#ο ޽
		AUTHOR		=> $data_line[4], 		#۾
		DATE		=> $data_line[5], 		#¥
		TIME		=> $data_line[6], 		#ð
		MSG_ICON	=> "<img src=\"$CONFIG->{images_url}/icons/$data_line[8].gif\" align=\"absmiddle\">", #  
		USE_TAG		=> $use_tag,
		nav_bar		=> $self->navigation_bar(__PACKAGE__, $IN->{cid}, $IN->{b}) . "亯 ۾",
		JSCRIPT		=> DB->JSEmotion_CHCode(),
		EMOTION_CHCODE	=> DB->emotion_chcode(),
		hidden_tag	=> $hidden_tag,
		forum_name	=> $forum_info->{Name},
		poster		=> $name,
		message_icons	=> DB->message_icon("gif") );
}

#----------------------------------------------------------------------
