package Plugins::SendPM;

use strict;
use Setup qw/$CONFIG $VARS/;
use CH::Getform;
use CH::DBUtil;
use vars qw/@ISA/;

@ISA = qw/Board/;

#----------------------------------------------------------------------
#
#----------------------------------------------------------------------
sub new {
	bless my $self = {};
	
	if ( $MEMBER->login_name ) {
		$self->{TEMPLATE} = DB->load_template("send_pm.html");
		$self->{TEMPLATE}->param( DB->style_vars("ȸ  ") );
		$self->{output} = "";
		
			if ($IN->{action} eq "go") { $self->process; }
			else { $self->send_form; }
		
			$self->{TEMPLATE}->output;
	}
	else { $SESSION->member_login; }
}

#----------------------------------------------------------------------
#
#----------------------------------------------------------------------
sub send_form {
	my $self = shift;
	my $to = $self->member_data($IN->{ID});
	my $level = $self->member_level($to->{MEMBER_LEVEL});
	
	$self->{output} = qq|
	$VARS->{spacer}
	<form method="post" action="index.cgi">
	<input type="hidden" name="do" value="SendPM">
	<input type="hidden" name="action" value="go">
	<input type="hidden" name="to" value="$to->{USER_ID}">
	<input type="hidden" name="from" value="191">
	$VARS->{table_top}
		<table $VARS->{table}>
		<tr $VARS->{bg_header}>
			<td colspan="2"><$VARS->{header_font}><b> </b></font>
			</td>
		</tr>
		<tr $VARS->{bg_color1}>
			<td width="25%"><$VARS->{font}>޴ :</font>
			</td>
			<td width="75%"><$VARS->{font}>$to->{MEMBER_ID} ($level)</font>
			</td>
		</tr>
		<tr $VARS->{bg_color2}>
			<td width="25%"><$VARS->{font}> :</font>
			</td>
			<td width="75%"><input type="text" name="subject" size="30">
			</td>
		</tr>
		<tr $VARS->{bg_color1}>
			<td valign="top"><$VARS->{font}> :</font></td>
			<td>
			<textarea wrap="virtual" name="body" rows="10" cols="50"></textarea>
			</td>
		</tr>
		</table>
	$VARS->{table_bottom}
	$VARS->{spacer}
	
	<table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr><td width="25%">&nbsp;</td>
	<td width="75%"><input type="submit" value=" "> <input type="reset" value="ٽ ۼ">
	</td></tr>
	</table>
	</form>|;
	
	$self->{TEMPLATE}->param(
			nav_bar		=> $self->navigation_bar("ȸ  "),
			html_output 	=> $self->{output} 
			);
}

#----------------------------------------------------------------------
#
#----------------------------------------------------------------------
sub process {
	my $self = shift;
	my $to = $self->member_data($IN->{to});
	my $level = $self->member_level($to->{MEMBER_LEVEL});

	my $uid = $to->{USER_ID};
	my $pm = {};
	
	my $id = $IN->{from} . "-" . time;
	if (-e "$CONFIG->{pm_path}/$uid.cgi") {
		$pm = DB->get_data("$CONFIG->{pm_path}/$uid.cgi");
	}
	
	$IN->{body} = DB->message_check($IN->{body});
	$IN->{subject} = DB->text_trim($IN->{subject});
	
	$pm->{$id} = [ $IN->{subject}, $IN->{body}, DB->current_date ];
	
	DB->_lock("$uid.cgi");
	open (FH, ">$CONFIG->{pm_path}/$uid.cgi");
		print FH CH::Dumper->dump( data => $pm, var => '' );
	close FH;
	DB->_unlock("$uid.cgi");
	
	$self->{output} = qq|
	$VARS->{spacer}
	$VARS->{table_top}
		<table $VARS->{table}>
		<tr $VARS->{bg_header}>
			<td colspan="2"><$VARS->{header_font}><b>  Ϸ!</b></font>
			</td>
		</tr>
		<tr $VARS->{bg_color1}>
			<td width="25%"><$VARS->{font}>޴ :</font>
			</td>
			<td width="75%"><$VARS->{font}>$to->{MEMBER_ID} ($level)</font>
			</td>
		</tr>
		<tr $VARS->{bg_color2}>
			<td><$VARS->{font}> :</font>
			</td>
			<td><$VARS->{font}>$IN->{subject}</font>
			</td>
		</tr>
		<tr $VARS->{bg_color1}>
			<td valign="top"><$VARS->{font}> :</font></td>
			<td><$VARS->{font}>$IN->{body}</font>
			</td>
		</tr>
		</table>
	$VARS->{table_bottom}
	$VARS->{spacer}|;

	$self->{TEMPLATE}->param( 
			nav_bar		=> $self->navigation_bar("  Ϸ!"),
			html_output 	=> $self->{output}
			);
}
