#===================================================================
#       	    --------------------------
#           	             CHBoard
#		    --------------------------
#
#     : âȣ.
#       : contact@koinweb.co.kr
#   Ȩ: http://www.koinweb.co.kr
#       : Setup.pm
#
# Copyright (C) 2001 Koinweb - All rights reserved.
#  α׷  Ǿ   ϰų  
# Ǹ  ϴ.
#
#===================================================================

package Setup;

require 5.005;

#----------------------------------------------------------------------
use strict;
use base qw(CH::Base);
use CH::Getform;
use vars qw($CONFIG $VARS $LANG $PLUGINS $AUTOLOAD $ERROR $DEBUG);

$DEBUG		= 0 unless defined $DEBUG;
$ERROR		= '';

$PLUGINS	= 'CH::Plugins';

sub load {
	my ($class, $module) = @_;
	$module =~ s,::,/,g;
	$module .= '.pm';
	eval { require $module; };

	return $@ ? $class->error(" ε  ϴ.: $@") : 1;
}

sub plugins {
	my ($class, $module) = @_;
	my $params = defined $_[0] && UNIVERSAL::isa($_[0], 'HASH') ? shift : { @_ };

	return undef unless $class->load($module);
	return $PLUGINS->new($params) || $class->error("÷    ϴ. ",
		$PLUGINS->error);
}



#----------------------------------------------------------------------
#
# ʱ ϰ , øƮ    Ʈ.
#
#----------------------------------------------------------------------
sub import {
	my $class = shift;
	my $call_class = caller;

	no strict 'refs';
	*{$call_class . '::CONFIG'} = \$CONFIG;
	$CONFIG = do "data/chboard.cfg";
	
	*{$call_class . '::VARS'} = \$VARS;
	$VARS = do "data/vars.txt";
	
	*{$call_class . '::LANG'} = \$LANG;
	$LANG = do "language/korean.rc";
}

#----------------------------------------------------------------------
1;
